#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "dpu2kernel4xi.py">
#<abstract4xi abstract = "DPU kernel management"/>
#<refer4xi reference = "kernel4xi.py"/>
#<verify4xi verification = "10" target = "dpu2kernel4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API  
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'DPU2Kernel4Xi',                       # ACK 5.7.1  p157    

            'add2kernel4dpu',                      # ACK               

            'execute2kernel4dpu',                  # ACK 5.8    p169                                             
            'execute2task4dpu',                    # ACK 5.8    p172   
            'execute2nativekernel4dpu',            # ACK 5.8    p174     
            
            'create2kernel4dpu',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram4dpu',         # ACK 5.7.1  p158  
                       
            'delete2kernel4dpu',                   # ACK

            'fetch2kernel4dpu',                    # ACK 
            
            'get2kernelinfo4dpu',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo4dpu',         # ACK 5.7.3  p164  
            'get2kernelarginfo4dpu',               # ACK 5.7.3  p166                                  
            
            'release2kernel4dpu',                  # ACK 5.7.1  p159                                         
            'retain2kernel4dpu',                   # ACK 5.7.1  p159   
 
            'set2kernel4dpu',                      # ACK 
            'set2kernelcallback4dpu',              # ACK 
            'set2kernelarg4dpu',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel4dpu'                     # ACK 

          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from dpu2buffer4xi import get2bufferinfo4dpu

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from dpu2commandqueue4xi import DPU2CommandQueue4Xi
from dpu2commandqueue4xi import create2commandqueue4dpu 
from dpu2commandqueue4xi import flush2commandqueue4dpu
from dpu2commandqueue4xi import finish2commandqueue4dpu
from dpu2commandqueue4xi import get2commandqueueinfo4dpu
from dpu2commandqueue4xi import release2commandqueue4dpu
from dpu2commandqueue4xi import retain2commandqueue4dpu
from dpu2commandqueue4xi import set2commandqueue4dpu
from dpu2commandqueue4xi import trace2commandqueue4dpu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from dpu2context4xi import DPU2Context4Xi 
from dpu2context4xi import create2context4dpu
from dpu2context4xi import get2context4dpu
from dpu2context4xi import release2context4dpu
from dpu2context4xi import retain2context4dpu
from dpu2context4xi import set2context4dpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from dpu2device4xi import DPU4Xi
from dpu2device4xi import init2dpu4xi 
from dpu2device4xi import set2dpu4xi
from dpu2device4xi import get2dpu4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from dpu2event4xi import DPU2Event4Xi
from dpu2event4xi import create2event4dpu
from dpu2event4xi import get2eventinfo4dpu
from dpu2event4xi import release2event4dpu
from dpu2event4xi import retain2event4dpu
from dpu2event4xi import set2eventcallback4dpu 
from dpu2event4xi import set2event4dpu
from dpu2event4xi import trace2event4dpu
from dpu2event4xi import wait2event4dpu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from dpu2program4xi import DPU2Program4Xi
from dpu2program4xi import add2programwithsource4dpu
from dpu2program4xi import add2programwithbinary4dpu
from dpu2program4xi import build2program4dpu
from dpu2program4xi import compile2program4dpu
from dpu2program4xi import create2programwithsource4dpu
from dpu2program4xi import create2programwithbinary4dpu
from dpu2program4xi import delete2programwithsource4dpu
from dpu2program4xi import delete2programwithbinary4dpu
from dpu2program4xi import get2programinfo4dpu
# from dpu2program4xi import get2programbuildinfo4dpu
from dpu2program4xi import link2program4dpu
from dpu2program4xi import release2program4dpu
from dpu2program4xi import retain2program4dpu
from dpu2program4xi import set2programcallback4dpu 
from dpu2program4xi import set2programwithsource4dpu
from dpu2program4xi import set2programwithbinary4dpu
from dpu2program4xi import trace2program4dpu
# from dpu2program4xi import unload2compiler4dpu

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from process4xi import Process4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                         
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global dpu2kernel4xi                                                    # Kernel of DPU
global dpu2build4xi                                                     # Build of DPU
global dpu2compile4xi                                                   # Compile of DPU
global dpu2trace4xi                                                     # TRACE

global fetch2code4dpu                                                   # Fetched code

global import2use4dpu                                                   # Imports of target function for Process4Xi

global kb2fetch4dpu                                                     # Knowledgebase for fetching
global kb2kernel4dpu                                                    # Knowledgebase for kernel   

global folder2lib4dpu                                                   # Folder of DPU library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4dpu

global target2function4dpu                                              # Target function for Process4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2dpu = 'dpu'
key2dir = temp2dpu[0]                                                                                               # MORE COMPLICATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4dpu = VersionKB4Xi[key2dir] 

profile2fetch = {}                                                                                                  # PROFILES FOR FETCHING
profile2fetch ['.py']  = 'ACK'                                                                                    
profile2fetch ['.pyc'] = 'ACK'                                                                                    
profile2fetch ['.cpp'] = 'ACK'                                                                                   
profile2fetch ['.exe'] = 'ACK'       
keys2profile4dpu = profile2fetch.keys()

kb2fetch4dpu = {}                                                                                                   # PROGRAMS TO BE FETCHED - ALWAYS DEFINE BOTH SOURCE AND BINARY PAIRS                               
kb2fetch4dpu[1] = folder2lib4dpu + 'dpu2sampler4xi5test.py'                                                         # Python code
kb2fetch4dpu[2] = folder2lib4dpu + '__pycache__//dpu2sampler4xi.cpython-33.pyc'   
kb2fetch4dpu[3] = folder2lib4dpu + 'dpu2dummy4xi5test.cpp'                                                          # C++ code
kb2fetch4dpu[4] = folder2lib4dpu + "bin//dpu2dummy4xi5test.exe"                                                     # C++ binary

# kb2fetch4dpu[1]  = folder2lib4dpu + 'dpu2sampler4xi5test.py'                                                      
# kb2fetch4dpu[2]  = folder2lib4dpu + '__pycache__//dpu2sampler4xi.cpython-33.pyc'                                  
# kb2fetch4dpu[3]  = folder2lib4dpu + 'dpu2image4xi5test.py'
# kb2fetch4dpu[4]  = folder2lib4dpu + '__pycache__//dpu2image4xi.cpython-33.pyc'
# kb2fetch4dpu[5]  = folder2lib4dpu + 'dpu3image4xi5test.py'
# kb2fetch4dpu[6]  = folder2lib4dpu + '__pycache__//dpu3image4xi.cpython-33.pyc'
# kb2fetch4dpu[7]  = folder2lib4dpu + 'dpu2commandqueue4xi5test.py'
# kb2fetch4dpu[8]  = folder2lib4dpu + '__pycache__//dpu2commandqueue4xi.cpython-33.pyc'
# kb2fetch4dpu[9]  = folder2lib4dpu + 'dpu2event4xi5test.py'
# kb2fetch4dpu[10] = folder2lib4dpu + '__pycache__//dpu2event4xi.cpython-33.pyc'
# kb2fetch4dpu[10]  = folder2lib4dpu + 'DPU2kernel4xi5test.py'
# kb2fetch4dpu[11] = folder2lib4dpu + '__pycache__//dpu2program.cpython-33.pyc'

fetch2code4dpu = {}                                                                                                 # reception arena in memory for code

kb2kernel4dpu = {}
kb2kernel4dpu ['.py'] = {}
kb2kernel4dpu ['.py'] ['TAG']            = "<function4xi function ="                                                
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4dpu ['.py'] ['VALUE']          = "dpu2sampler4xi5test" 
kb2kernel4dpu ['.py'] ['ATTRIBUTE']      = 'usage = "' 

kb2kernel4dpu ['.cpp'] = {}
kb2kernel4dpu ['.cpp'] ['TAG']            = "<function4xi function ="                                               
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4dpu ['.cpp'] ['VALUE']          = "dpu2dummy4xi5test" 
kb2kernel4dpu ['.cpp'] ['ATTRIBUTE']      = 'usage = "kernel'                                                       

#"/>

# -------------------------------------------------------------------------------------------------
# Command queue module of DPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2commandqueue4dpu" usage = " importing target function for Process4Xi">
def importcreate2commandqueue4dpu():
   global target2function4dpu
   from dpu2commandqueue4xi import create2commandqueue4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importflush2commandqueue4dpu" usage = " importing target function for Process4Xi">
def importflush2commandqueue4dpu():
   global target2function4dpu
   from dpu2commandqueue4xi import flush2commandqueue4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importfinish2commandqueue4dpu" usage = " importing target function for Process4Xi">
def importfinish2commandqueue4dpu():
   global target2function4dpu
   from dpu2commandqueue4xi import finish2commandqueue4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importget2commandqueueinfo4dpu" usage = " importing target function for Process4Xi">
def importget2commandqueueinfo4dpu():
   global target2function4dpu
   from dpu2commandqueue4xi import get2commandqueueinfo4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importrelease2commandqueue4dpu" usage = " importing target function for Process4Xi">
def importrelease2commandqueue4dpu():
   global target2function4dpu
   from dpu2commandqueue4xi import release2commandqueue4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importretain2commandqueue4dpu" usage = " importing target function for Process4Xi">
def importretain2commandqueue4dpu():
   global target2function4dpu
   from dpu2commandqueue4xi import retain2commandqueue4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importset2commandqueue4dpu" usage = " importing target function for Process4Xi">
def importset2commandqueue4dpu():
   global target2function4dpu
   from dpu2commandqueue4xi import set2commandqueue4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importtrace2commandqueue4dpu" usage = " importing target function for Process4Xi">
def importtrace2commandqueue4dpu():
   global target2function4dpu
   from dpu2commandqueue4xi import trace2commandqueue4dpu as target2function4dpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Context module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2context4dpu" usage = " importing target function for Process4Xi">
def importcreate2context4dpu():
   global target2function4dpu
   from dpu2context4xi import create2context4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importget2context4dpu" usage = " importing target function for Process4Xi">
def importget2context4dpu():
   global target2function4dpu
   from dpu2context4xi import get2context4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importrelease2context4dpu" usage = " importing target function for Process4Xi">
def importrelease2context4dpu():
   global target2function4dpu
   from dpu2context4xi import release2context4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importretain2context4dpu" usage = " importing target function for Process4Xi">
def importretain2context4dpu():
   global target2function4dpu
   from dpu2context4xi import retain2context4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importset2context4dpu" usage = " importing target function for Process4Xi">
def importset2context4dpu():
   global target2function4dpu
   from dpu2context4xi import set2context4dpu as target2function4dpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Device module of DPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importinit2dpu4xi" usage = " importing target function for Process4Xi">
def importinit2dpu4xi():
   global target2function4dpu
   from dpu2device4xi import init2dpu4xi as target2function4dpu 
#</function4xi>
 
#<function4xi function = "importset2dpu4xi" usage = " importing target function for Process4Xi">
def importset2dpu4xi():
   global target2function4dpu
   from dpu2device4xi import set2dpu4xi   as target2function4dpu
#</function4xi>
 
#<function4xi function = "importget2dpu4xi" usage = " importing target function for Process4Xi">
def importget2dpu4xi():
   global target2function4dpu
   from dpu2device4xi import get2dpu4xi   as target2function4dpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Event module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2event4dpu" usage = " importing target function for Process4Xi">
def importcreate2event4dpu():
   global target2function4dpu
   from dpu2event4xi import create2event4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importget2eventinfo4dpu" usage = " importing target function for Process4Xi">
def importget2eventinfo4dpu():
   global target2function4dpu
   from dpu2event4xi import get2eventinfo4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importrelease2event4dpu" usage = " importing target function for Process4Xi">
def importrelease2event4dpu():
   global target2function4dpu
   from dpu2event4xi import release2event4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importretain2event4dpu" usage = " importing target function for Process4Xi">
def importretain2event4dpu():
   global target2function4dpu
   from dpu2event4xi import retain2event4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importset2eventcallback4dpu" usage = " importing target function for Process4Xi">
def importset2eventcallback4dpu():
   global target2function4dpu
   from dpu2event4xi import set2eventcallback4dpu as target2function4dpu 
#</function4xi>
 
#<function4xi function = "importset2event4dpu" usage = " importing target function for Process4Xi">
def importset2event4dpu():
   global target2function4dpu
   from dpu2event4xi import set2event4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importtrace2event4dpu" usage = " importing target function for Process4Xi">
def importtrace2event4dpu():
   global target2function4dpu
   from dpu2event4xi import trace2event4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importwait2event4dpu" usage = " importing target function for Process4Xi">
def importwait2event4dpu():
   global target2function4dpu
   from dpu2event4xi import wait2event4dpu as target2function4dpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# 2D Image module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2image4dpu" usage = " importing target function for Process4Xi">
def importcreate2image4dpu():
   global target2function4dpu
   from dpu2image4xi import create2image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importget2imageinfo4dpu" usage = " importing target function for Process4Xi">
def importget2imageinfo4dpu():
   global target2function4dpu
   from dpu2image4xi import get2imageinfo4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importget2supportedimageformats4dpu" usage = " importing target function for Process4Xi">
def importget2supportedimageformats4dpu():
   global target2function4dpu
   from dpu2image4xi import get2supportedimageformats4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimage4dpu():
   global target2function4dpu
   from dpu2image4xi import manoeuvre2copyimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimagetobuffer4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimagetobuffer4dpu():
   global target2function4dpu
   from dpu2image4xi import manoeuvre2copyimagetobuffer4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copybuffertoimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copybuffertoimage4dpu():
   global target2function4dpu
   from dpu2image4xi import manoeuvre2copybuffertoimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2readimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2readimage4dpu():
   global target2function4dpu
   from dpu2image4xi import manoeuvre2readimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2writeimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2writeimage4dpu():
   global target2function4dpu
   from dpu2image4xi import manoeuvre2writeimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2mapimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2mapimage4dpu():
   global target2function4dpu
   from dpu2image4xi import manoeuvre2mapimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importcopy2image4dpu" usage = " importing target function for Process4Xi">
def importcopy2image4dpu():
   global target2function4dpu
   from dpu2image4xi import copy2image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importcopy2imagetobuffer4dpu" usage = " importing target function for Process4Xi">
def importcopy2imagetobuffer4dpu():
   global target2function4dpu
   from dpu2image4xi import copy2imagetobuffer4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importcopy2buffertoimage4dpu" usage = " importing target function for Process4Xi">
def importcopy2buffertoimage4dpu():
   global target2function4dpu
   from dpu2image4xi import copy2buffertoimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importread2image4dpu" usage = " importing target function for Process4Xi">
def importread2image4dpu():
   global target2function4dpu
   from dpu2image4xi import read2image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmap2image4dpu" usage = " importing target function for Process4Xi">
def importmap2image4dpu():
   global target2function4dpu
   from dpu2image4xi import map2image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importrelease2image4dpu" usage = " importing target function for Process4Xi">
def importrelease2image4dpu():
   global target2function4dpu
   from dpu2image4xi import release2image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importretain2image4dpu" usage = " importing target function for Process4Xi">
def importretain2image4dpu():
   global target2function4dpu
   from dpu2image4xi import retain2image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importset2imagecallback4dpu" usage = " importing target function for Process4Xi">
def importset2imagecallback4dpu():
   global target2function4dpu
   from dpu2image4xi import set2imagecallback4dpu as target2function4dpu 
#</function4xi>
 
#<function4xi function = "importset2image4dpu" usage = " importing target function for Process4Xi">
def importset2image4dpu():
   global target2function4dpu
   from dpu2image4xi import set2image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importtrace2image4dpu" usage = " importing target function for Process4Xi">
def importtrace2image4dpu():
   global target2function4dpu
   from dpu2image4xi import trace2image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importwait2image4dpu" usage = " importing target function for Process4Xi">
def importwait2image4dpu():
   global target2function4dpu
   from dpu2image4xi import wait2image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importwrite2image4dpu" usage = " importing target function for Process4Xi">
def importwrite2image4dpu():
   global target2function4dpu
   from dpu2image4xi import write2image4dpu as target2function4dpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# 3D Image module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate3image4dpu" usage = " importing target function for Process4Xi">
def importcreate3image4dpu():
   global target2function4dpu
   from dpu3image4xi import create3image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importget3imageinfo4dpu" usage = " importing target function for Process4Xi">
def importget3imageinfo4dpu():
   global target2function4dpu
   from dpu3image4xi import get3imageinfo4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importget3supportedimageformats4dpu" usage = " importing target function for Process4Xi">
def importget3supportedimageformats4dpu():
   global target2function4dpu
   from dpu3image4xi import get3supportedimageformats4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimage4dpu():
   global target2function4dpu
   from dpu3image4xi import manoeuvre3copyimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimagetobuffer4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimagetobuffer4dpu():
   global target2function4dpu
   from dpu3image4xi import manoeuvre3copyimagetobuffer4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copybuffertoimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copybuffertoimage4dpu():
   global target2function4dpu
   from dpu3image4xi import manoeuvre3copybuffertoimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3readimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3readimage4dpu():
   global target2function4dpu
   from dpu3image4xi import manoeuvre3readimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3writeimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3writeimage4dpu():
   global target2function4dpu
   from dpu3image4xi import manoeuvre3writeimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3mapimage4dpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3mapimage4dpu():
   global target2function4dpu
   from dpu3image4xi import manoeuvre3mapimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importcopy3image4dpu" usage = " importing target function for Process4Xi">
def importcopy3image4dpu():
   global target2function4dpu
   from dpu3image4xi import copy3image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importcopy3imagetobuffer4dpu" usage = " importing target function for Process4Xi">
def importcopy3imagetobuffer4dpu():
   global target2function4dpu
   from dpu3image4xi import copy3imagetobuffer4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importcopy3buffertoimage4dpu" usage = " importing target function for Process4Xi">
def importcopy3buffertoimage4dpu():
   global target2function4dpu
   from dpu3image4xi import copy3buffertoimage4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importread3image4dpu" usage = " importing target function for Process4Xi">
def importread3image4dpu():
   global target2function4dpu
   from dpu3image4xi import read3image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importmap3image4dpu" usage = " importing target function for Process4Xi">
def importmap3image4dpu():
   global target2function4dpu
   from dpu3image4xi import map3image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importrelease3image4dpu" usage = " importing target function for Process4Xi">
def importrelease3image4dpu():
   global target2function4dpu
   from dpu3image4xi import release3image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importretain3image4dpu" usage = " importing target function for Process4Xi">
def importretain3image4dpu():
   global target2function4dpu
   from dpu3image4xi import retain3image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importset3imagecallback4dpu" usage = " importing target function for Process4Xi">
def importset3imagecallback4dpu():
   global target2function4dpu
   from dpu3image4xi import set3imagecallback4dpu as target2function4dpu 
#</function4xi>
 
#<function4xi function = "importset3image4dpu" usage = " importing target function for Process4Xi">
def importset3image4dpu():
   global target2function4dpu
   from dpu3image4xi import set3image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importtrace3image4dpu" usage = " importing target function for Process4Xi">
def importtrace3image4dpu():
   global target2function4dpu
   from dpu3image4xi import trace3image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importwait3image4dpu" usage = " importing target function for Process4Xi">
def importwait3image4dpu():
   global target2function4dpu
   from dpu3image4xi import wait3image4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importwrite3image4dpu" usage = " importing target function for Process4Xi">
def importwrite3image4dpu():
   global target2function4dpu
   from dpu3image4xi import write3image4dpu as target2function4dpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Sampler module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2sampler4dpu" usage = " importing target function for Process4Xi">
def importcreate2sampler4dpu():
   global target2function4dpu
   from dpu2sampler4xi import create2sampler4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importget2samplerinfo4dpu" usage = " importing target function for Process4Xi">
def importget2samplerinfo4dpu():
   global target2function4dpu
   from dpu2sampler4xi import get2samplerinfo4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importrelease2sampler4dpu" usage = " importing target function for Process4Xi">
def importrelease2sampler4dpu():
   global target2function4dpu
   from dpu2sampler4xi import release2sampler4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importretain2sampler4dpu" usage = " importing target function for Process4Xi">
def importretain2sampler4dpu():
   global target2function4dpu
   from dpu2sampler4xi import retain2sampler4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importset2samplercallback4dpu" usage = " importing target function for Process4Xi">
def importset2samplercallback4dpu():
   global target2function4dpu
   from dpu2sampler4xi import set2samplercallback4dpu as target2function4dpu 
#</function4xi>
 
#<function4xi function = "importset2sampler4dpu" usage = " importing target function for Process4Xi">
def importset2sampler4dpu():
   global target2function4dpu
   from dpu2sampler4xi import set2sampler4dpu as target2function4dpu
#</function4xi>
 
#<function4xi function = "importtrace2sampler4dpu" usage = " importing target function for Process4Xi">
def importtrace2sampler4dpu():
   global target2function4dpu
   from dpu2sampler4xi import trace2sampler4dpu as target2function4dpu
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# Program module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2programwithsource4dpu" usage = " importing target function for Process4Xi">
def importcreate2programwithsource4dpu():
   global target2function4dpu
   from dpu2kernel4xi import create2programwithsource4dpu as target2function4dpu
#</function4xi> 

#<function4xi function = "importcreate2programwithbinary4dpu" usage = " importing target function for Process4Xi">
def importcreate2programwithbinary4dpu():
   global target2function4dpu
   from dpu2kernel4xi import create2programwithbinary4dpu as target2function4dpu
#</function4xi> 

#<function4xi function = "importadd2programwithsource4dpu" usage = " importing target function for Process4Xi">
def importadd2programwithsource4dpu():
   global target2function4dpu
   from dpu2kernel4xi import add2programwithsource4dpu as target2function4dpu
#</function4xi> 

#<function4xi function = "importadd2programwithbinary4dpu" usage = " importing target function for Process4Xi">
def importadd2programwithbinary4dpu():
   global target2function4dpu
   from dpu2kernel4xi import add2programwithbinary4dpu as target2function4dpu
#</function4xi>

#<function4xi function = "importbuild2program4dpu" usage = " importing target function for Process4Xi">
def importbuild2program4dpu():
   global target2function4dpu
   from dpu2kernel4xi import build2program4dpu as target2function4dpu
#</function4xi>

#<function4xi function = "importbuild2program4dpu" usage = " importing target function for Process4Xi">
def importbuild2program4dpu():
   global target2function4dpu
   from dpu2kernel4xi import build2program4dpu as target2function4dpu
#</function4xi>

#<function4xi function = "importcompile2program4dpuX" usage = " importing target function for Process4Xi">
def importcompile2program4dpu():
   global target2function4dpu
   from dpu2kernel4xi import compile2program4dpu as target2function4dpu
#</function4xi>

#<function4xi function = "importdelete2programwithsource4dpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithsource4dpu():
   global target2function4dpu
   from dpu2kernel4xi import delete2programwithsource4dpu as target2function4dpu
#</function4xi>    

#<function4xi function = "importdelete2programwithbinary4dpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithbinary4dpu():
   global target2function4dpu
   from dpu2kernel4xi import delete2programwithbinary4dpu as target2function4dpu
#</function4xi>    

#<function4xi function = "importget2programinfo4dpuX" usage = " importing target function for Process4Xi">
def importget2programinfo4dpu():
   global target2function4dpu
   from dpu2kernel4xi import get2programinfo4dpu as target2function4dpu
#</function4xi>    

#<function4xi function = "importlink2program4dpuX" usage = " importing target function for Process4Xi">
def importlink2program4dpu():
   global target2function4dpu
   from dpu2kernel4xi import link2program4dpu as target2function4dpu
#</function4xi>    

#<function4xi function = "importrelease2program4dpuX" usage = " importing target function for Process4Xi">
def importrelease2program4dpu():
   global target2function4dpu
   from dpu2kernel4xi import release2program4dpu as target2function4dpu
#</function4xi>    

#<function4xi function = "importretain2program4dpuX" usage = " importing target function for Process4Xi">
def importretain2program4dpu():
   global target2function4dpu
   from dpu2kernel4xi import retain2program4dpu as target2function4dpu
#</function4xi>    

#<function4xi function = "importset2programcallback4dpuX" usage = " importing target function for Process4Xi">
def importset2programcallback4dpu():
   global target2function4dpu
   from dpu2kernel4xi import set2programcallback4dpu as target2function4dpu
#</function4xi>    

#<function4xi function = "importset2programwithsource4dpuX" usage = " importing target function for Process4Xi">
def importset2programwithsource4dpu():
   global target2function4dpu
   from dpu2kernel4xi import set2programwithsource4dpu as target2function4dpu
#</function4xi>    

#<function4xi function = "importset2programwithbinary4dpuX" usage = " importing target function for Process4Xi">
def importset2programwithbinary4dpu():
   global target2function4dpu
   from dpu2kernel4xi import set2programwithbinary4dpu as target2function4dpu
#</function4xi>    

#<function4xi function = "importtrace2program4dpuX" usage = " importing target function for Process4Xi">
def importtrace2program4dpu():
   global target2function4dpu
   from dpu2kernel4xi import trace2program4dpu as target2function4dpu
#</function4xi>    

# -------------------------------------------------------------------------------------------------
# Test modules of DPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importdpu2commandqueue4xi5test" usage = " importing target function for Process4Xi">
def importdpu2commandqueue4xi5test():
   global target2function4dpu
   from dpu2commandqueue4xi5test import dpu2commandqueue4xi5test as target2function4dpu
#</function4xi> 

#<function4xi function = "importdpu2event4xi5test" usage = " importing target function for Process4Xi">
def importdpu2event4xi5test():
   global target2function4dpu
   from dpu2event4xi5test import dpu2event4xi5test as target2function4dpu
#</function4xi>
 
#<function4xi function = "importdpu2image4xi5test" usage = " importing target function for Process4Xi">
def importdpu2image4xi5test():
   global target2function4dpu
   from dpu2image4xi5test import dpu2image4xi5test as target2function4dpu
#</function4xi>
 
#<function4xi function = "importdpu3image4xi5test" usage = " importing target function for Process4Xi">
def importdpu3image4xi5test():
   global target2function4dpu
   from dpu3image4xi5test import dpu3image4xi5test as target2function4dpu
#</function4xi>
 
#<function4xi function = "importdpu2sampler4xi5test" usage = " importing target function for Process4Xi">
def importdpu2sampler4xi5test():
   global target2function4dpu
   from dpu2sampler4xi5test import dpu2sampler4xi5test as target2function4dpu
#</function4xi>
 
#<function4xi function = "importDPU2kernel4xi5test" usage = " importing target function for Process4Xi">
def importdpu2kernel4xi5test():
   global target2function4dpu
   from dpu2kernel4xi5test import dpu2kernel4xi5test as target2function4dpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Error handler of DPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "handle2error4dpu" usage = " Error handling for importing target function for Process4Xi">
def handle2error4dpu():
   global import2use4dpu
   print ("HANDLE2ERROR4DPU OF DPU2KERNEL4XI.PY: *** FAILED TO IMPORT TARGET FUNCTION ***")
   keys2import4dpu = import2use4dpu.keys()
   for key2import4dpu in keys2import4dpu:
       print(key2import4dpu,import2use4dpu[key2import4dpu]) 
#</function4xi> 


import2use4dpu = {}
# -------------------------------------------------------------------------------------------------
# Command queue module of DPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4dpu["create2commandqueue4dpu"] = importcreate2commandqueue4dpu        
import2use4dpu["flush2commandqueue4dpu"] = importflush2commandqueue4dpu 
import2use4dpu["finish2commandqueue4dpu"] = importfinish2commandqueue4dpu 
import2use4dpu["get2commandqueueinfo4dpu"] = importget2commandqueueinfo4dpu 
import2use4dpu["release2commandqueue4dpu"] = importrelease2commandqueue4dpu 
import2use4dpu["retain2commandqueue4dpu"] = importretain2commandqueue4dpu 
import2use4dpu["set2commandqueue4dpu"] = importset2commandqueue4dpu 
import2use4dpu["trace2commandqueue4dpu"] = importtrace2commandqueue4dpu 

# -------------------------------------------------------------------------------------------------
# Context module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dpu["create2context4dpu"] = importcreate2context4dpu 
import2use4dpu["get2context4dpu"] = importget2context4dpu 
import2use4dpu["release2context4dpu"] = importrelease2context4dpu 
import2use4dpu["retain2context4dpu"] = importretain2context4dpu 
import2use4dpu["set2context4dpu"] = importset2context4dpu 

# -------------------------------------------------------------------------------------------------
# Device module of DPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4dpu["init2dpu4xi"] = importinit2dpu4xi 
import2use4dpu["set2dpu4xi"] = importset2dpu4xi 
import2use4dpu["get2dpu4xi"] = importget2dpu4xi 

# -------------------------------------------------------------------------------------------------
# Event module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dpu["create2event4dpu"] = importcreate2event4dpu 
import2use4dpu["get2eventinfo4dpu"] = importget2eventinfo4dpu 
import2use4dpu["release2event4dpu"] = importrelease2event4dpu 
import2use4dpu["retain2event4dpu"] = importretain2event4dpu 
import2use4dpu["set2eventcallback4dpu"] = importset2eventcallback4dpu 
import2use4dpu["set2event4dpu"] = importset2event4dpu 
import2use4dpu["trace2event4dpu"] = importtrace2event4dpu 
import2use4dpu["wait2event4dpu"] = importwait2event4dpu 

# -------------------------------------------------------------------------------------------------
# 2D Image module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dpu["create2image4dpu"] = importcreate2image4dpu 
import2use4dpu["get2imageinfo4dpu"] = importget2imageinfo4dpu 
import2use4dpu["get2supportedimageformats4dpu"] = importget2supportedimageformats4dpu 
import2use4dpu["manoeuvre2copyimage4dpu"] = importmanoeuvre2copyimage4dpu 
import2use4dpu["manoeuvre2copyimagetobuffer4dpu"] = importmanoeuvre2copyimagetobuffer4dpu 
import2use4dpu["manoeuvre2copybuffertoimage4dpu"] = importmanoeuvre2copybuffertoimage4dpu 
import2use4dpu["manoeuvre2readimage4dpu"] = importmanoeuvre2readimage4dpu 
import2use4dpu["manoeuvre2writeimage4dpu"] = importmanoeuvre2writeimage4dpu 
import2use4dpu["manoeuvre2mapimage4dpu"] = importmanoeuvre2mapimage4dpu 
import2use4dpu["copy2image4dpu"] = importcopy2image4dpu 
import2use4dpu["copy2imagetobuffer4dpu"] = importcopy2imagetobuffer4dpu 
import2use4dpu["copy2buffertoimage4dpu"] = importcopy2buffertoimage4dpu 
import2use4dpu["read2image4dpu"] = importread2image4dpu 
import2use4dpu["map2image4dpu"] = importmap2image4dpu 
import2use4dpu["release2image4dpu"] = importrelease2image4dpu 
import2use4dpu["retain2image4dpu"] = importretain2image4dpu 
import2use4dpu["set2imagecallback4dpu"] = importset2imagecallback4dpu 
import2use4dpu["set2image4dpu"] = importset2image4dpu 
import2use4dpu["trace2image4dpu"] = importtrace2image4dpu 
import2use4dpu["wait2image4dpu"] = importwait2image4dpu 
import2use4dpu["write2image4dpu"] = importwrite2image4dpu 

# -------------------------------------------------------------------------------------------------
# 3D Image module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dpu["create3image4dpu"] = importcreate3image4dpu 
import2use4dpu["get3imageinfo4dpu"] = importget3imageinfo4dpu 
import2use4dpu["get3supportedimageformats4dpu"] = importget3supportedimageformats4dpu 
import2use4dpu["manoeuvre3copyimage4dpu"] = importmanoeuvre3copyimage4dpu 
import2use4dpu["manoeuvre3copyimagetobuffer4dpu"] = importmanoeuvre3copyimagetobuffer4dpu 
import2use4dpu["manoeuvre3copybuffertoimage4dpu"] = importmanoeuvre3copybuffertoimage4dpu 
import2use4dpu["manoeuvre3readimage4dpu"] = importmanoeuvre3readimage4dpu 
import2use4dpu["manoeuvre3writeimage4dpu"] = importmanoeuvre3writeimage4dpu 
import2use4dpu["manoeuvre3mapimage4dpu"] = importmanoeuvre3mapimage4dpu 
import2use4dpu["copy3image4dpu"] = importcopy3image4dpu 
import2use4dpu["copy3imagetobuffer4dpu"] = importcopy3imagetobuffer4dpu 
import2use4dpu["copy3buffertoimage4dpu"] = importcopy3buffertoimage4dpu 
import2use4dpu["read3image4dpu"] = importread3image4dpu 
import2use4dpu["map3image4dpu"] = importmap3image4dpu 
import2use4dpu["release3image4dpu"] = importrelease3image4dpu 
import2use4dpu["retain3image4dpu"] = importretain3image4dpu 
import2use4dpu["set3imagecallback4dpu"] = importset3imagecallback4dpu 
import2use4dpu["set3image4dpu"] = importset3image4dpu 
import2use4dpu["trace3image4dpu"] = importtrace3image4dpu 
import2use4dpu["wait3image4dpu"] = importwait3image4dpu 
import2use4dpu["write3image4dpu"] = importwrite3image4dpu 

# -------------------------------------------------------------------------------------------------
# Sampler module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dpu["create2sampler4dpu"] = importcreate2sampler4dpu 
import2use4dpu["get2samplerinfo4dpu"] = importget2samplerinfo4dpu 
import2use4dpu["release2sampler4dpu"] = importrelease2sampler4dpu 
import2use4dpu["retain2sampler4dpu"] = importretain2sampler4dpu 
import2use4dpu["set2samplercallback4dpu"] = importset2samplercallback4dpu 
import2use4dpu["set2sampler4dpu"] = importset2sampler4dpu 
import2use4dpu["trace2sampler4dpu"] = importtrace2sampler4dpu 

# -------------------------------------------------------------------------------------------------
# Program module of DPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4dpu["trace2program4dpu"] = importtrace2program4dpu
import2use4dpu["set2programwithbinary4dpu"] = importset2programwithbinary4dpu
import2use4dpu["set2programwithsource4dpu"] = importset2programwithsource4dpu
import2use4dpu["set2programcallback4dpu"] = importset2programcallback4dpu
import2use4dpu["retain2program4dpu"] = importretain2program4dpu
import2use4dpu["release2program4dpu"] = importrelease2program4dpu
import2use4dpu["link2program4dpu"] = importlink2program4dpu
import2use4dpu["get2programinfo4dpu"] = importget2programinfo4dpu
import2use4dpu["delete2programwithbinary4dpu"] = importdelete2programwithbinary4dpu
import2use4dpu["delete2programwithsource4dpu"] = importdelete2programwithsource4dpu
import2use4dpu["compile2program4dpu"] = importcompile2program4dpu
import2use4dpu["build2program4dpu"] = importbuild2program4dpu
import2use4dpu["build2program4dpu"] = importbuild2program4dpu
import2use4dpu["add2programwithbinary4dpu"] = importadd2programwithbinary4dpu
import2use4dpu["add2programwithsource4dpu"] = importadd2programwithsource4dpu
import2use4dpu["create2programwithbinary4dpu"] = importcreate2programwithbinary4dpu
import2use4dpu["create2programwithsource4dpu"] = importcreate2programwithsource4dpu



# -------------------------------------------------------------------------------------------------
# Test modules of DPU imports for target function                             
# -------------------------------------------------------------------------------------------------
import2use4dpu["dpu2commandqueue4xi5test"] = importdpu2commandqueue4xi5test 
import2use4dpu["dpu2event4xi5test"] = importdpu2event4xi5test 
import2use4dpu["dpu2image4xi5test"] = importdpu2image4xi5test 
import2use4dpu["dpu3image4xi5test"] = importdpu3image4xi5test 
import2use4dpu["dpu2sampler4xi5test"] = importdpu2sampler4xi5test 
import2use4dpu["dpu2kernel4xi5test"] = importdpu2kernel4xi5test 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2kernel4dpu" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF DPU2KERNEL4XI5TEST - TRYING TO TRACE DPU: ', time4xi())      
#   print('=' *33)      
#   trace2dpu = None
#   try:
#       trace2dpu = trace2kernel4dpu() 
#       print('(Step 15B/25) OF DPU2KERNEL4XI5TEST - TRACE2DPU: ', trace2dpu)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4dpu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4dpu', 'METHOD': 'trace2kernel4dpu'} 
#   except:
#       print('(Step 15Z1/25) OF DPU2KERNEL4XI5TEST *** FAILED TO TRACE DPU: ', trace2dpu) 
#      
#">

# -------------------------------------------------------------------------------------------------   
def trace2kernel4dpu(task4trace2dpu=None):  

    '''
    creates callback to dpu2kernel4xi
    '''
    
    global dpu2trace4xi
    global folder2lib4dpu    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2kernel4dpu" 
    method2print = "trace2kernel4dpu"

    message2print = "{(Step 1A/33) started" + "; trace2kernel4dpu-started: " + str(trace2kernel4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                               
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2dpu-to-trace2kernel4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    dpu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2dpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY DPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2dpu = {}                                                                                            
            
        task4trace2dpu['CLASS']   = "trace2kernel4dpu"                                                              # DPUIZE ZPU TRACE!
        task4trace2dpu['METHOD']  = "trace2kernel4dpu" 
        task4trace2dpu['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2kernel4dpu-failed " + str(dpu2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2dpu-set-by-trace2kernel4dpu to: " + str(task4trace2dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY DPUIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2dpu-try-by-trace2kernel4dpu: " + str(task4trace2dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # 

    try:
        dpu2trace4xi ['CLASS']  = task4trace2dpu['CLASS']                                                           # DPUIZE DPU TRACE!
        dpu2trace4xi ['METHOD']  = task4trace2dpu['METHOD']
        dpu2trace4xi ['MESSAGE'] = task4trace2dpu['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; dpu2trace4xi-set-by-trace2kernel4dpu to: " + str(dpu2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; dpu-trace-failed-by-trace2kernel4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE DPU TRACE
        # =================================
        class2print   = task4trace2dpu['CLASS']                                                                     # DPUIZE DPU TRACE!
        method2print  = task4trace2dpu['METHOD']
        
        message2print = task4trace2dpu['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                          # DPUIZED TRACE FOR OPENCL CALLBACK!
        # 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2kernel4dpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4dpu"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-dpu-trace-failed-by-trace2kernel4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2kernel4dpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4dpu"                
        message2print = "{(Step 3D/33) performed" + "; dpu-trace-performed-by-trace2kernel4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; dpu-trace-failed-by-trace2kernel4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; dpu2trace4xi-returning-by-trace2kernel4dpu: " + str(dpu2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return dpu2trace4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2kernel4dpu" usage = "
#
#   response4execute2kernel = execute2kernel4dpu()
#      
#">

# -------------------------------------------------------------------------------------------------   
def execute2kernel4dpu(task4execute2dpu=None):  

    '''
    executes kernel to DPU 
    '''
    global folder2lib4dpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2kernel4dpu" 
    method2print = "execute2kernel4dpu"

    message2print = "{(Step 1A/33) started" + "; execute2kernel4dpu-started: " + str(execute2kernel4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
          
    message2print = "{(Step 1B/33) passed" + "; task4execute2dpu-to-execute2kernel4dpu: " + str(task4execute2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                            # 
    # 
    status4execute2dpu = 'CL_SUCCESS'
    
    code2ack  = ' '
    code2nack = ' '    
    
                                                                                                                  #       
    if task4execute2dpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN - BUILD THEM
        # -----------------------------------------------------------------------------------------    
        task4execute2dpu = {}                                                                                            

        message2print = "{(Step 2A/33) set" + "; task4execute2dpu-set-by-execute2kernel4dpu to: " + str(task4execute2dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------          
    status4execute2dpu = 'CL_SUCCESS'
    message2print = "{(Step 3A/33) set" + "; status4execute2dpu-set-by-execute2kernel4dpu to: " + str(status4execute2dpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; status4execute2dpu-returning-by-execute2kernel4dpu: " + str(status4execute2dpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return status4execute2dpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelcallback4dpu" usage = "
#
#   print('(Step 14A/700) OF DPU2KERNEL4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF DPU ', time4xi())  
#   try:                               
#       response4setcallback2program = set2kernelcallback4dpu()                                                                                                 
#       print('(Step 14B/700) OF DPU2KERNEL4XI5TEST - SET PROGRAM CALLBACK OF DPU TO: ', response4setcallback2program)   
#       # 
#   except:
#       print('(Step 14Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF DPU ', time4xi())  
# 
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2kernelcallback4dpu(task4set2kernelcallback=None):

    '''
    registers callback function to dpu2kernel4xi
    '''
    global dpu2kernel4xi
    global folder2lib4dpu  
        
    class2print = "set2kernelcallback4dpu" 
    method2print = "set2kernelcallback4dpu"
    
    message2print = "{(Step 2A/70) started" + "; set2kernelcallback4dpu-started: " + str(set2kernelcallback4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # set2kernelcallback4dpu-started
    
    try:
    
        dpu2kernel4xi ['CALLBACK'] = trace2kernel4dpu
        
        
        message2print = "{(Step 2C/70) returning" + "; callback-of-dpu2kernel4xi-returning-by-set2kernelcallback4dpu: " + str(dpu2kernel4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # 
        
        return dpu2kernel4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 2Z1/70) failed" + "; callback2program-failed-by-set2kernelcallback4dpu: " + str(callback2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 2Z2/70) returning" + "; trace2kernel4dpu-returning-by-set2kernelcallback4dpu: " + str(trace2kernel4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2kernel4dpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2task4dpu" usage = "
#
#   try:                               
#       response4execute2task = execute2task4dpu(task4execute2task)
#       print('(Step 99B/700) OF DPU2KERNEL4XI5TEST - BUILT PROGRAM OF DPU DEVICE ', time4xi())
#   except:
#       print('(Step 99Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO EXECUTE PROGRAM OF DPU DEVICE ', time4xi())  
#                 
#">

# -------------------------------------------------------------------------------------------------   
def execute2task4dpu(task4execute2dpu=None):

    '''
    executes  program to DPU 
    '''
    global dpu2execute4xi
    global folder2lib4dpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2task4dpu"
    method2print = "execute2task4dpu" 

    message2print = "{(Step 1A/33) started" + "; execute2task4dpu-started: " + str(execute2task4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # execute2task4dpu-started
    
    
    message2print = "{(Step 1B/33) passed" + "; task4execute2dpu-to-execute2task4dpu: " + str(task4execute2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
             
    code2ack  = ' '
    code2nack = ' '

    message2print = "{(Step 1A/70) try" + "; execute-try-by-execute2task4dpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    try:             
        if task4execute2dpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - EXECUTE TASK TO DPU! 
            # -----------------------------------------------------------------------------------------    
            task4execute2dpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4execute2dpu-initialized-by-execute2task4dpu: " + str(task4execute2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (1) KERNEL REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            program2dpu = {}
            message2print = "{(Step 1A/70) trying" + "; program2dpu-trying-by-create2kernel4dpu: " + str(program2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                program2dpu = create2kernel4dpu()                                                                     
                
                message2print = "{(Step 1B/70) got" + "; program2dpu-got-by-create2kernel4dpu: " + str(program2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                #                 
                code2ack  = code2ack + '1B-'         
            except:
                message2print = "{(Step 1Z/70) failed" + "; program2dpu-failed-by-create2kernel4dpu: " + str(program2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '1Z-'
                
            task4execute2dpu ['PROGRAM'] = program2dpu
            
            # ---------------------------------------------------------------------------------------------
            # (2) OPTIONS - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            task4execute2task  ['OPTIONS'] = {}
          
            
            # ---------------------------------------------------------------------------------------------
            # (3) CALLBACK - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            function2callback4dpu = trace2kernel4dpu                                                               # CALLBACK FUNCTION FOR DPU
            
            message2print = "{(Step 3A/70) initialized" + "; function2callback4dpu-created-by-execute2task4dpu: " + str(function2callback4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '3A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "execute2task4dpu"                                                            # MODULE OF DPUIZED OPENCL MODULE
            args2callback['METHOD']  = "execute2task4dpu"                                                            # FUNCTION OF DPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 3Z1/33) failed" + "; execute2task4dpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DPUIZED OPENCL TO RETURN    

            message2print = "{(Step 3B/70) initialized" + "; args2callback-created-by-execute2task4dpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '3B-'
            
           
            task4execute2dpu['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO DPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4execute2dpu['FUNCTION2CALLBACK'] = function2callback4dpu                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '3C-'

            
            # ---------------------------------------------------------------------------------------------
            # (4) USERDATA - REQUIRED                         
            # ---------------------------------------------------------------------------------------------
            task4execute2dpu['USERDATA'] = None 
            
            message2print = "{(Step 4A/70) initialized" + "; task4execute2dpu-created-by-execute2task4dpu: " + str(task4execute2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        else:
            pass                                                                  
    except:
        message2print = "{(Step 1Z1/70) yielded" + "; task4execute2dpu-yielded-by-execute2task4dpu: " + str(task4execute2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-'  
                                                                                                 
    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4execute2dpu.keys()        
    message2print = "{(Step 9/70) using" + "; keys2task-using-by-execute2task4dpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 
  
    # ---------------------------------------------------------------------------------------------
    # (Step 10A/70) - CREATE EXECUTE FOR DPU ! 
    # ---------------------------------------------------------------------------------------------    
    dpu2execute4xi = {}                                                                                                                                                                               
    message2print = "{(Step 10A/70) initialized" + "; dpu2execute4xi-initialized-by-execute2task4dpu to: " + str(dpu2execute4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    message2print = "{(Step 11A0/70) try" + "; program-try-by-execute2task4dpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11A/70) - PROGRAM - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        dpu2execute4xi['PROGRAM'] = task4execute2dpu['PROGRAM']
        
        message2print = "{(Step 11A1/70) initialized" + "; program-created-by-execute2task4dpu: " + str(dpu2execute4xi['PROGRAM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '11A1-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; program-dpu2execute4xi-yielded-by-execute2task4dpu: " + str(dpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-' 
           
    message2print = "{(Step 12A0/70) try" + "; options-try-by-execute2task4dpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12A/70) - OPTIONS - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        dpu2execute4xi['OPTIONS'] = task4execute2dpu['OPTIONS']
        
        message2print = "{(Step 12A1/70) initialized" + "; options-created-by-execute2task4dpu: " + str(dpu2execute4xi['OPTIONS'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '12A1-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; options-dpu2execute4xi-yielded-by-execute2task4dpu: " + str(dpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
        
    message2print = "{(Step 13A0/70) try" + "; callback-try-by-execute2task4dpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13A/70) - CALLBACK - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        dpu2execute4xi['CALLBACK'] = task4execute2dpu['CALLBACK']
        
        message2print = "{(Step 13A1/70) initialized" + "; callback-created-by-execute2task4dpu: " + str(dpu2execute4xi['CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '13A1-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; callback-dpu2execute4xi-yielded-by-execute2task4dpu: " + str(dpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-' 
        
    message2print = "{(Step 14A0/70) try" + "; userdata-try-by-execute2task4dpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14A/70) - USERDATA - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        dpu2execute4xi['USERDATA'] = task4execute2dpu['USERDATA']
        
        message2print = "{(Step 14A1/70) initialized" + "; userdata-created-by-execute2task4dpu: " + str(dpu2execute4xi['USERDATA'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '14A1-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; userdata-dpu2execute4xi-yielded-by-execute2task4dpu: " + str(dpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'
                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2execute4xi ['ACK2RETURN']  = code2ack
    dpu2execute4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; dpu2execute4xi-returning-by-execute2task4dpu: " + str(dpu2execute4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return dpu2execute4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernel4dpu" usage = "
#     
#   print('(Step 2A1/700) OF DPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR DPU ', time4xi())       
#   try:
#       response4create2kernel = create2kernel4dpu()
#   except:
#       print('(Step 2Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR DPU *** ', time4xi())
#          
#">

# -------------------------------------------------------------------------------------------------   
def create2kernel4dpu(task4kernel2dpu=None):

    '''
    creates kernel for DPU
    '''
    global dpu2kernel4xi                                                                                            # Kernel of DPU    
    global folder2lib4dpu  
    global kb2kernel4dpu                                                                                            # Knowledgebase for kernel      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernel4dpu" 
    method2print = "create2kernel4dpu"

    message2print = "{(Step 1A/70) started" + "; create2kernel4dpu-started: " + str(create2kernel4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2kernel4dpu at 0x0000000003AAD8C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2dpu-to-create2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #1: None
    #2: 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    dpu2kernel4xi = {}                                                                                              # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernel2dpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO DPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4kernel2dpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4kernel2dpu-created-by-create2kernel4dpu: " + str(task4kernel2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                 
            # ---------------------------------------------------------------------------------------------
                        
            function2callback4dpu = trace2kernel4dpu                                                                # CALLBACK FUNCTION FOR DPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4dpu-created-by-create2kernel4dpu: " + str(function2callback4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4dpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4dpu"                                                          # MODULE OF DPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4dpu"                                                          # FUNCTION OF DPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4dpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4dpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dpu',
            #  'METHOD': 'create2kernel4dpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2dpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO DPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2dpu['FUNCTION2CALLBACK'] = function2callback4dpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2dpu-created-by-create2kernel4dpu: " + str(task4kernel2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4dpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dpu',
            #  'METHOD': 'create2kernel4dpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}


            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2kernel4dpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2kernel4dpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 03:33:11 12/06/11 Pacific Standard Time}
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2kernel4dpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4kernel2dpu['PLATFORM'] = platform2xi                                                               # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - EXTRA                   
            # ---------------------------------------------------------------------------------------------    
            context2dpu = {}
            message2print = "{(Step 3A/70) trying" + "; context2dpu-trying-by-create2kernel4dpu: " + str(context2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2dpu = get2context4dpu()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2dpu-got-by-create2kernel4dpu: " + str(context2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2dpu-failed-by-create2kernel4dpu: " + str(context2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4kernel2dpu ['CONTEXT'] = context2dpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------    
            device2dpu = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2dpu-trying-by-create2kernel4dpu: " + str(device2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2dpu = get2dpu4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2dpu-got-by-create2kernel4dpu: " + str(device2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2dpu-failed-by-create2kernel4dpu: " + str(device2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4kernel2dpu ['DEVICE'] = device2dpu
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4kernel2dpu ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2dpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2dpu-trying-by-create2kernel4dpu: " + str(queue2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2dpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2dpu-got-by-create2kernel4dpu: " + str(queue2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2dpu-failed-by-create2kernel4dpu: " + str(queue2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2dpu ['QUEUE'] = queue2dpu

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2dpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2dpu-trying-by-create2kernel4dpu: " + str(pipe2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2dpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2dpu-got-by-create2kernel4dpu: " + str(pipe2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2dpu-failed-by-create2kernel4dpu: " + str(pipe2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2dpu ['PIPE'] = pipe2dpu 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2dpu = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2dpu-trying-by-create2kernel4dpu: " + str(commandqueueinfo2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2dpu = get2commandqueueinfo4dpu()                                                   # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2dpu-got-by-create2kernel4dpu: " + str(commandqueueinfo2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2dpu-failed-by-create2kernel4dpu: " + str(commandqueueinfo2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4kernel2dpu ['COMMANDQUEUE'] = commandqueueinfo2dpu
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2dpu = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2dpu-trying-by-create2kernel4dpu: " + str(bufferinfo2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2dpu = get2bufferinfo4dpu()                                                               # SYSTEM CREATES BUFFER FOR DPU, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2dpu-got-by-create2kernel4dpu: " + str(bufferinfo2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2dpu-failed-by-create2kernel4dpu: " + str(bufferinfo2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4kernel2dpu ['BUFFER'] = bufferinfo2dpu 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2dpu = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2dpu-trying-by-create2kernel4dpu: " + str(eventinfo2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2dpu = get2eventinfo4dpu()                                                                 # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2dpu-got-by-create2kernel4dpu: " + str(eventinfo2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ... 
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2dpu-failed-by-create2kernel4dpu: " + str(eventinfo2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4kernel2dpu ['EVENT'] = eventinfo2dpu             

            
            task4kernel2dpu ['CODE4PY']       = {}                                                                  
            task4kernel2dpu ['CODE4CPP']      = {}                                                                  
            task4kernel2dpu ['CODE4C']        = {} 
            task4kernel2dpu ['CODE4CL']       = {} 
                       
            task4kernel2dpu ['CODE4PYC']      = {}                                                                  
            task4kernel2dpu ['CODE4BIN']      = {}
 
            task4kernel2dpu ['DIRECTORY4PY']  = {}                                                                  
            task4kernel2dpu ['DIRECTORY4CPP'] = {}
            task4kernel2dpu ['DIRECTORY4C']   = {}
            task4kernel2dpu ['DIRECTORY4CL']  = {}
                                                                                                       
            task4kernel2dpu ['DIRECTORY4PYC'] = {}                                                                  
            task4kernel2dpu ['DIRECTORY4BIN'] = {}                                                                  
                                               
            # ---------------------------------------------------------------------------------------------
            # (12A0) DIRECTORY4PY - PYTHON                 
            # ---------------------------------------------------------------------------------------------             
            dir2py4dpu = folder2lib4dpu                                                                                                                                                            
            message2print = "{(Step 12A0/70) set" + "; dir2py4dpu-set-by-create2kernel4dpu to: " + str(dir2py4dpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu 
            code2ack  = code2ack + '12A0-' 
        
            task4kernel2dpu ['DIRECTORY4PY'] = dir2py4dpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A0) CODE4PY - PYTHON         
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A0/70) using" + "; DirectoryWalker-using-by-create2kernel4dpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2py4dpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B0/70) examining" + "; directory-examining-by-create2kernel4dpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C0/70) examining" + "; file-examining-by-create2kernel4dpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4dpu + dpu2sampler4xi5test.py; dpu2dummy4xi5test.cpp 
                    
                    message2print = "{(Step 14D0/70) calling" + "; fetch2kernel4dpu-calling-by-create2kernel4dpu: " + str(fetch2kernel4dpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4dpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E0/70) passing" + "; file2walk-passing-to-fetch2kernel4dpu-by-create2kernel4dpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4dpu + dpu2sampler4xi5test.py; dpu2dummy4xi5test.cpp 
                    
                    fetch2kernel4dpu(file2walk)                                                                     # FETCHES KERNEL FILES INTO FETCH2CODE4DPU DICTIONARY 
                    
                    message2print = "{(Step 14E0/70) performed" + "; fetch2kernel4dpu-performed-by-create2kernel4dpu: " + str(fetch2kernel4dpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4dpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14F0/70) got" + "; fetch2code4dpu-got-by-create2kernel4dpu: " + str(fetch2code4dpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # ...  {1: '...profile = "11" />\n', 2: '# --
            
            
                     
            keys2explore4dpu = fetch2code4dpu.keys()
            message2print = "{(Step 14G0/70) using" + "; keys2explore4dpu-using-by-create2kernel4dpu: " + str(keys2explore4dpu) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)             
            # folder2lib4dpu + dpu2sampler4xi5test.py; dpu2dummy4xi5test.cpp
            
            for key2explore4dpu in keys2explore4dpu:
                name2program4dpu=os.path.splitext(key2explore4dpu)                                                  # dpu2sampler4xi5test + py
                key2extension4dpu = name2program4dpu[1]                                                              
                if key2extension4dpu == '.py':                          
                    task4kernel2dpu ['CODE4PY'] [key2explore4dpu] = fetch2code4dpu[key2explore4dpu]                 # Python code(s)      

            # ---------------------------------------------------------------------------------------------
            # (14H0) SIZE4PY - PYTHON SOURCE            
            # ---------------------------------------------------------------------------------------------                                                
            size2py4dpu  = {}
            keys2py4dpu = fetch2code4dpu.keys()                                                                     # dpu2sampler4xi5test.py
            for key2py4dpu in keys2py4dpu:
                name2program4dpu=os.path.splitext(key2py4dpu)                                                       # dpu2sampler4xi5test + py
                key2extension4dpu = name2program4dpu[1]                                                             # py   
                if key2extension4dpu == '.py':                          
                    size2py4dpu[key2py4dpu] = len(fetch2code4dpu[key2py4dpu])                                       # length of saved py code 

            task4kernel2dpu ['SIZE4PY'] = size2py4dpu
                               
            message2print = "{(Step 14H0/70) set" + "; size2py4dpu-set-by-create2kernel4dpu to: " + str(size2py4dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {folder2lib4dpu + dpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '14H1-' 
            

            # ---------------------------------------------------------------------------------------------
            # (12A1) C, C++, CL SOURCE                   
            # ---------------------------------------------------------------------------------------------             
            dir2c4dpu = folder2lib4dpu                                                                                                                                                            
            message2print = "{(Step 12A1/70) set" + "; dir2c4dpu-set-by-create2kernel4dpu to: " + str(dir2c4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # folder2lib4dpu 
            code2ack  = code2ack + '12A1-' 
        
            task4kernel2dpu ['DIRECTORY4CPP']  = dir2c4dpu
            task4kernel2dpu ['DIRECTORY4C']    = dir2c4dpu
            task4kernel2dpu ['DIRECTORY4CLPP'] = dir2c4dpu
            task4kernel2dpu ['CODE4CPP'] = {} 
            task4kernel2dpu ['CODE4C']   = {} 
            task4kernel2dpu ['CODE4CL']  = {}            
            
            # ---------------------------------------------------------------------------------------------
            # (14A1) C, C++, CL SOURCE   
            # ---------------------------------------------------------------------------------------------             
            keys2c4dpu = fetch2code4dpu.keys()
            for key2c4dpu in keys2c4dpu:
                name2c4dpu=os.path.splitext(key2c4dpu)                                                  
                key2extension4dpu = name2c4dpu[1]                                                             # C++, C, CL 
                if key2extension4dpu == '.cpp':                          
                    task4kernel2dpu ['CODE4CPP'] [key2c4dpu] = fetch2code4dpu[key2c4dpu]                     
                    message2print = "{(Step 14G1/70) set" + "; key2c4dpu-set-by-create2kernel4dpu to: " + str(key2c4dpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4dpu + dpu2dummy4xi5test.cpp
                if key2extension4dpu == '.c':                          
                    task4kernel2dpu ['CODE4C'] [key2c4dpu] = fetch2code4dpu[key2c4dpu]                     
                    message2print = "{(Step 14G2/70) set" + "; key2c4dpu-set-by-create2kernel4dpu to: " + str(key2c4dpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4dpu +
                if key2extension4dpu == '.cl':                          
                    task4kernel2dpu ['CODE4CL'] [key2c4dpu] = fetch2code4dpu[key2c4dpu]                     
                    message2print = "{(Step 14G3/70) set" + "; key2c4dpu-set-by-create2kernel4dpu to: " + str(key2c4dpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4dpu + 
                                                                
            # ----------------------------------------------------------------------------------------------
            # (14H1) SIZE4C - C C++ CL SOURCE HAS THE SAME FOLDER AS FOR PYTHON SOURCE - ALREADY FETCHED           
            # ----------------------------------------------------------------------------------------------                                                
            size2c4dpu  = {}
            keys2c4dpu = fetch2code4dpu.keys()                                                                # 
            for key2c4dpu in keys2c4dpu:
                name2program4dpu=os.path.splitext(key2c4dpu)                                                  # 
                key2extension4dpu = name2program4dpu[1]                                                       #    
                if key2extension4dpu == '.cpp':                          
                    size2c4dpu[key2c4dpu] = len(fetch2code4dpu[key2c4dpu])                                    # length of saved C++ code
                    task4kernel2dpu ['SIZE4CPP'] = size2c4dpu 
                if key2extension4dpu == '.c':                          
                    size2c4dpu[key2c4dpu] = len(fetch2code4dpu[key2c4dpu])                                    # length of saved C code
                    task4kernel2dpu ['SIZE4C'] = size2c4dpu
                if key2extension4dpu == '.cl':                          
                    size2c4dpu[key2c4dpu] = len(fetch2code4dpu[key2c4dpu])                                    # length of saved CL code
                    task4kernel2dpu ['SIZE4CL'] = size2c4dpu 
                                       
            
                               
            message2print = "{(Step 14H1/70) set" + "; size2c4dpu-set-by-create2kernel4dpu to: " + str(size2c4dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu + dpu2dummy4xi5test.cpp': 331}
            code2ack  = code2ack + '14H1-' 
            
                                                  
            # ---------------------------------------------------------------------------------------------
            # (12B2) DIRECTORY FOR PYTHON CACHE - REQUIRED                      
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4dpu = folder2lib4dpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 12B2/70) set" + "; dir2pycache4dpu-set-by-create2kernel4dpu to: " + str(dir2pycache4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu + '__pycache__//'
            code2ack  = code2ack + '12B2-' 
        
            task4kernel2dpu ['DIRECTORY4PYC'] = dir2pycache4dpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A2) CODE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A2/70) using" + "; DirectoryWalker-using-by-create2kernel4dpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2pycache4dpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B2/70) examining" + "; directory-examining-by-create2kernel4dpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C2/70) examining" + "; file-examining-by-create2kernel4dpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4dpu + __pycache__//dpu2sampler4xi5test.cpython-33.pyc
                    
                    message2print = "{(Step 14D2/70) calling" + "; fetch2kernel4dpu-calling-by-create2kernel4dpu: " + str(fetch2kernel4dpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4dpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E2/70) passing" + "; file2walk-passing-to-fetch2kernel4dpu-by-create2kernel4dpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4dpu + __pycache__//dpu2sampler4xi5test.cpython-33.pyc
                    
                    fetch2kernel4dpu(file2walk)                                                                     # fetches kernel files into fetch2code4dpu dictionary 
                    
                    message2print = "{(Step 14F2/70) performed" + "; fetch2kernel4dpu-performed-by-create2kernel4dpu: " + str(fetch2kernel4dpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4dpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14G2/70) got" + "; fetch2code4dpu-got-by-create2kernel4dpu: " + str(fetch2code4dpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # 
            
            task4kernel2dpu ['CODE4PYC'] = {}
            keys2pyc4dpu = fetch2code4dpu.keys()
            for key2pyc4dpu in keys2pyc4dpu:
                name2program4dpu=os.path.splitext(key2pyc4dpu)                                                      # dpu2sampler4xi5test.cpython-33.pyc
                key2extension4dpu = name2program4dpu[1]                                                             # pyc 
   
                if key2extension4dpu == '.pyc':                          
                    task4kernel2dpu ['CODE4PYC'] [key2pyc4dpu] = fetch2code4dpu[key2pyc4dpu]                        # binary code(s)
                    message2print = "{(Step 14H2/70) set" + "; key2pyc4dpu-set-by-create2kernel4dpu to: " + str(key2pyc4dpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    #    
                                     
            size2pyc4dpu  = {}

            for key2pyc4dpu in keys2pyc4dpu:
                name2program4dpu=os.path.splitext(key2pyc4dpu)                                                      # dpu2sampler4xi5test.cpython-32 + pyc
                key2extension4dpu = name2program4dpu[1]                                                             # pyc 
                if key2extension4dpu == '.pyc':                          
                    size2pyc4dpu[key2pyc4dpu] = len(fetch2code4dpu[key2pyc4dpu])                                    # length of saved binary code
                    message2print = "{(Step 14I2/70) set" + "; key2pyc4dpu-set-by-create2kernel4dpu to: " + str(key2pyc4dpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # 
                                              
            # ---------------------------------------------------------------------------------------------
            # (14I2) SIZE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2dpu ['SIZE4PYC'] = size2pyc4dpu
                               
            message2print = "{(Step 14J2/70) set" + "; size2pyc4dpu-set-by-create2kernel4dpu to: " + str(size2pyc4dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 
            code2ack  = code2ack + '14J2-' 

                                               
            # ---------------------------------------------------------------------------------------------
            # (12A3) DIRECTORY FOR C++, C, CL BIN - REQUIRED                    
            # ---------------------------------------------------------------------------------------------             
            dir2bin4dpu = folder2lib4dpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4dpu-set-by-create2kernel4dpu to: " + str(dir2bin4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2dpu ['DIRECTORY4BIN'] = dir2bin4dpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A3) CODE4BIN FOR C++, C, CL - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A3/70) using" + "; DirectoryWalker-using-by-create2kernel4dpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2bin4dpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B3/70) examining" + "; directory-examining-by-create2kernel4dpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C3/70) examining" + "; file-examining-by-create2kernel4dpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4dpu + bin//dpu2dummy4xi5test.exe
                    
                    message2print = "{(Step 14D3/70) calling" + "; fetch2kernel4dpu-calling-by-create2kernel4dpu: " + str(fetch2kernel4dpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4dpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E3/70) passing" + "; file2walk-passing-to-fetch2kernel4dpu-by-create2kernel4dpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4dpu + bin//dpu2dummy4xi5test.exe
                    
                    fetch2kernel4dpu(file2walk)                                                                     # fetches kernel files into fetch2code4dpu dictionary 
                    
                    message2print = "{(Step 14E3/70) performed" + "; fetch2kernel4dpu-performed-by-create2kernel4dpu: " + str(fetch2kernel4dpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4dpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14F3/70) got" + "; fetch2code4dpu-got-by-create2kernel4dpu: " + str(fetch2code4dpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # 

            task4kernel2dpu ['CODE4BIN'] = {}
            
            keys2bin4dpu = fetch2code4dpu.keys()
            message2print = "{(Step 14G3/70) using" + "; keys2bin4dpu-using-by-create2kernel4dpu: " + str(keys2bin4dpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4dpu + 'dpu2dummy4xi5test.cpp', 'dpu2sampler4xi5test.py']
            
            for key2bin4dpu in keys2bin4dpu:
                name2program4dpu=os.path.splitext(key2bin4dpu)                                                      # dpu2dummy4xi5test.exe
                key2extension4dpu = name2program4dpu[1]                                                             # bin 
   
                if key2extension4dpu == '.exe':                          
                    task4kernel2dpu ['CODE4BIN'] [key2bin4dpu] = fetch2code4dpu[key2bin4dpu]                        # binary code(s)   
                                        
            size2bin4dpu  = {}
            keys2bin4dpu = fetch2code4dpu.keys()                                                                    # dpu2dummy4xi5test.exe
            for key2bin4dpu in keys2bin4dpu:
                name2program4dpu=os.path.splitext(key2bin4dpu)                                                      # dpu2sampler4xi5test.cpython-32 + bin
                key2extension4dpu = name2program4dpu[1]                                                             # bin 
                if key2extension4dpu == '.exe':                          
                    size2bin4dpu[key2bin4dpu] = len(fetch2code4dpu[key2bin4dpu])                                    # length of saved binary code
                        
            # ---------------------------------------------------------------------------------------------
            # (14H3) SIZE4BIN - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2dpu ['SIZE4BIN'] = size2bin4dpu
                               
            message2print = "{(Step 14H3/70) set" + "; size2bin4dpu-set-by-create2kernel4dpu to: " + str(size2bin4dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {}
            code2ack  = code2ack + '14H3-' 

            # ---------------------------------------------------------------------------------------------
            # (14J) COUNT4PY, COUNT4C,COUNT4PYC,COUNT4BIN                
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dpu ['COUNT4PY']     = 0
            task4kernel2dpu ['COUNT4CPP']    = 0
            task4kernel2dpu ['COUNT4C']      = 0
            task4kernel2dpu ['COUNT4CL']     = 0
            task4kernel2dpu ['COUNT4PYC']    = 0
            task4kernel2dpu ['COUNT4BIN']    = 0

            keys2code4dpu = fetch2code4dpu.keys()
            message2print = "{(Step 14J/70) using" + "; keys2code4dpu-using-by-create2kernel4dpu: " + str(keys2code4dpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4dpu + 'dpu2dummy4xi5test.cpp', folder2lib4dpu + 'dpu2sampler4xi5test.py']

            
            for key2code4dpu in keys2code4dpu:
                name2program4dpu=os.path.splitext(key2code4dpu)                                                    
                key2extension4dpu = name2program4dpu[1]                                                             
                if key2extension4dpu == '.py':                          
                    task4kernel2dpu ['COUNT4PY']     = task4kernel2dpu ['COUNT4PY']  + 1 
                if key2extension4dpu == '.cpp':                          
                    task4kernel2dpu ['COUNT4CPP']    = task4kernel2dpu ['COUNT4CPP'] + 1                                            
                if key2extension4dpu == '.c':                          
                    task4kernel2dpu ['COUNT4C']      = task4kernel2dpu ['COUNT4C']   + 1              
                if key2extension4dpu == '.cl':                          
                    task4kernel2dpu ['COUNT4CL']     = task4kernel2dpu ['COUNT4CL']  + 1                                  
                if key2extension4dpu == '.pyc':                          
                    task4kernel2dpu ['COUNT4PYC']    = task4kernel2dpu ['COUNT4PYC'] + 1                            
                if key2extension4dpu == '.exe':                          
                    task4kernel2dpu ['COUNT4BIN']    = task4kernel2dpu ['COUNT4BIN'] + 1                                                                                 
            
            message2print = "{(Step 14K/70) set" + "; count4py-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['COUNT4PY'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            
            message2print = "{(Step 14L/70) set" + "; count4cpp-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['COUNT4CPP'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            message2print = "{(Step 14M/70) set" + "; count4c-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['COUNT4C'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0 
            message2print = "{(Step 14N/70) set" + "; count4cl-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['COUNT4CL'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                         
            
            message2print = "{(Step 14M/70) set" + "; count4pyc-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['COUNT4PYC'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0
            
            message2print = "{(Step 14N/70) set" + "; count4bin-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['COUNT4BIN'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                                                
            code2ack  = code2ack + '14N-'
            
            # ---------------------------------------------------------------------------------------------
            # (15) LANGUAGE - EXTRA                             
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dpu ['LANGUAGE'] = {}
            
            for key2code4dpu in keys2code4dpu:
                name2program4dpu=os.path.splitext(key2code4dpu)                                                     
                key2extension4dpu = name2program4dpu[1]                                                             
                if key2extension4dpu == '.py':                          
                    task4kernel2dpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4dpu == '.cpp':                          
                    task4kernel2dpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4dpu == '.c':                          
                    task4kernel2dpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4dpu == '.cl':                          
                    task4kernel2dpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4dpu-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '15B-' 
                      
            # ---------------------------------------------------------------------------------------------
            # (16) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2dpu  = 1
           
            message2print = "{(Step 16B/70) set" + "; count2reference2dpu-set-by-create2kernel4dpu to: " + str(count2reference2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '16B-' 
        
            task4kernel2dpu ['COUNT2REFERENCE'] = count2reference2dpu                                 
                                    
            # ---------------------------------------------------------------------------------------------
            # (17) PROGRAM - REQUIRED                           
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dpu ['PROGRAM'] = None
            message2print = "{(Step 17A/70) try" + "; program2dpu-try-by-create2kernel4dpu: " + str(task4kernel2dpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2dpu ['PROGRAM'] = create2programwithsource4dpu()
                keys2program = task4kernel2dpu ['PROGRAM'].keys()
                
                message2print = "{(Step 17B/70) set" + "; program-set-by-create2kernel4dpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'COUNT2REFERENCE', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '17B-'
            except:
                message2print = "{(Step 17Z1/70) failed" + "; task4kernel2dpu-failed-by-create2kernel4dpu: " + str(task4kernel2dpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '17Z-'
                                    
            # ---------------------------------------------------------------------------------------------
            # (18) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2dpu ['FUNCTION'] = {}
            message2print = "{(Step 18A0/70) set" + "; function4dpu-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2dpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 18A1/70) set" + "; pythonfunction4dpu-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4dpu  = kb2kernel4dpu ['.py'] ['TAG']
            message2print = "{(Step 18A2/70) using" + "; tag2search4dpu-using-by-create2kernel4dpu: " + str(tag2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4dpu    = kb2kernel4dpu ['.py'] ['VALUE']
            message2print = "{(Step 18A3/70) using" + "; value2search4dpu-using-by-create2kernel4dpu: " + str(value2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # dpu2sampler4xi5test
            
            attribute2search4dpu= kb2kernel4dpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 18A4/70) using" + "; attribute2search4dpu-using-by-create2kernel4dpu: " + str(attribute2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4dpu in keys2code4dpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4dpu]
                    keys2line4dpu = code2examine4dpu.keys()
                    for key2line4dpu in keys2line4dpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4dpu] [key2line4dpu]
                        # message2print = "{(Step 18A5/70) examining" + "; line2examine4dpu-examining-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4dpu,tag2search4dpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 18B/70) examining" + "; line2function4dpu-examining-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # <... dpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4dpu,value2search4dpu)
                            if index2function == -1:
                                message2print = "{(Step 18C/70) skipped" + "; line2function4dpu-skipped-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # <... set2trace4sampler" ... # ...function = "dpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4dpu,attribute2search4dpu)             # ...function = "dpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 18D/70) warning" + "; line2function4dpu-warning-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 18E/70) accepted" + "; line2examine4dpu-accepted-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ...function = "dpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4dpu = line2examine4dpu[index2function:index2usage-2]
                                    
                                    task4kernel2dpu ['FUNCTION'] ['.py'] [key2pythonfunction4dpu] = {}                                  

                                    message2print = "{(Step 18F/70) used" + "; key2pythonfunction4dpu-used-by-create2kernel4dpu: " + str(key2pythonfunction4dpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # dpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '18F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 18Z1/70) failed" + "; task4kernel2dpu-failed-by-create2kernel4dpu: " + str(task4kernel2dpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '18Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (19) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2dpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 19A0F/70) set" + "; cplusfunction4dpu-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4dpu      = kb2kernel4dpu ['.cpp'] ['TAG']
            message2print = "{(Step 19A2/70) using" + "; tag2search4dpu-using-by-create2kernel4dpu: " + str(tag2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <...            
            attribute2search4dpu= kb2kernel4dpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 19A4/70) using" + "; attribute2search4dpu-using-by-create2kernel4dpu: " + str(attribute2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4dpu in keys2code4dpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4dpu]
                    message2print = "{(Step 19A5/70) using" + "; key2code4dpu-using-by-create2kernel4dpu: " + str(key2code4dpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # dpu2dummy4xi5test.cpp
                       
                    keys2line4dpu = code2examine4dpu.keys()
                    # message2print = "{(Step 19A6/70) using" + "; keys2line4dpu-using-by-create2kernel4dpu: " + str(keys2line4dpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4dpu in keys2line4dpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4dpu] [key2line4dpu]
                        # message2print = "{(Step 19A7/70) examining" + "; line2examine4dpu-examining-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # /*<... nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4dpu,tag2search4dpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 19B1/70) examining" + "; line2function4dpu-examining-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # ... function = "OCLError" usage = "error code checking"*/
                            # ... function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 19B2/70) using" + "; attribute2search4dpu-using-by-create2kernel4dpu: " + str(attribute2search4dpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4dpu,attribute2search4dpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 19C/70) skipped" + "; line2function4dpu-skipped-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 19E/70) accepted" + "; line2examine4dpu-accepted-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "nbody_kern" usage = "kernel example 1"*/; 
                                # ... function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4dpu = line2examine4dpu[27:index2usage-2]  
                                task4kernel2dpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4dpu] =  {}                                       

                                message2print = "{(Step 19F/70) used" + "; key2kernelfunction4dpu-used-by-create2kernel4dpu: " + str(key2kernelfunction4dpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '19F-'
                                    
                                    
            except:
                message2print = "{(Step 19Z1/70) failed" + "; task4kernel2dpu-failed-by-create2kernel4dpu: " + str(task4kernel2dpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #   
                #             
                code2nack  = code2nack + '19Z-'           
                                                      
            # ---------------------------------------------------------------------------------------------
            # EOF CREATING TASK4KERNEL2DPU                  
            # ---------------------------------------------------------------------------------------------                                                                                                                                                          
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernel2dpu-yielded-by-create2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4kernel2dpu.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2kernel4dpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #1 this program created:
    # ['BUFFER'  ... 'LANGUAGE', 'PIPE', 
    #  'PLATFORM', 'PROGRAM', 'QUEUE' ....']
    #2 caller passed:
    # ['FUNCTION', 'PROGRAM']
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE PROGRAM OBJECT FOR DPU - BUILD REQUIRED ONES IF USER HAS FORGOTTEN ! 
    # ---------------------------------------------------------------------------------------------    
    dpu2kernel4xi = {}                                                                                             # CREATE INITIALIZES DICTIONARY!                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; dpu2kernel4xi-initialized-by-create2kernel4dpu to: " + str(dpu2kernel4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    if (('DATA2CALLBACK' not in keys2task) or ('FUNCTION2CALLBACK' not in keys2task)):
        try:            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - REQUIRED                
            # ---------------------------------------------------------------------------------------------
                     
            function2callback4dpu = trace2kernel4dpu                                                                # CALLBACK FUNCTION FOR DPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4dpu-created-by-create2kernel4dpu: " + str(function2callback4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4dpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4dpu"                                                          # MODULE OF DPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4dpu"                                                          # FUNCTION OF DPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4dpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4dpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dpu',
            #  'METHOD': 'create2kernel4dpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2dpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO DPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2dpu['FUNCTION2CALLBACK'] = function2callback4dpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2dpu-created-by-create2kernel4dpu: " + str(task4kernel2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4dpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dpu',
            #  'METHOD': 'create2kernel4dpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}
        except: 
            message2print = "{(Step 1Z2/70) yielded" + "; callbacks-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'     
                
    if 'DATA2CALLBACK' in keys2task:
        message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2kernel4dpu: {}" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - DATA2CALLBACK - REQUIRED 
            # -----------------------------------------------------------------------------------------               
            dpu2kernel4xi['DATA2CALLBACK'] = task4kernel2dpu['DATA2CALLBACK']
            
            message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4dpu-failed ; time: 04:42:53 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4dpu',
            #  'METHOD': 'create2kernel4dpu'}
    
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; data2callback-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z1-'
    
    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - FUNCTION2CALLBACK - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernel2dpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2kernel4dpu at 0x000000000422F6C8>
            
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; function2callback-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z2-' 
        
        message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2kernel4dpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #

        
    if 'PLATFORM' in keys2task:         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22C/70) - PLATFORM - EXTRA
            # -----------------------------------------------------------------------------------------               
            dpu2kernel4xi['PLATFORM'] = task4kernel2dpu['PLATFORM']
            
            message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    
    
            code2ack  = code2ack + '22C1-'
        except: 
            message2print = "{(Step 22Z3/70) yielded" + "; platform-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z3-' 
            
    
    if 'CONTEXT' in keys2task:        
        message2print = "{(Step 23A/70) try" + "; context2dpu-try-by-create2kernel4dpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - CONTEXT  - EXTRA
            # -----------------------------------------------------------------------------------------               
            dpu2kernel4xi['CONTEXT'] = task4kernel2dpu['CONTEXT']
            
            message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...      
            
            code2ack  = code2ack + '23B-'
        except: 
            message2print = "{(Step 23Z1/70) yielded" + "; context-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
            code2nack  = code2nack + '23Z1-' 
    
    if 'DEVICE' in keys2task:        
        message2print = "{(Step 24A/70) try" + "; device-try-by-create2kernel4dpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 24/70) - DEVICE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dpu2kernel4xi['DEVICE'] = task4kernel2dpu['DEVICE']
            
            message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
            
            code2ack  = code2ack + '24B-'
        except: 
            message2print = "{(Step 24Z1/70) yielded" + "; device-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '24Z1-'
    
    if 'CODE2ERROR' in keys2task:                     
        message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 25/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dpu2kernel4xi['CODE2ERROR'] = task4kernel2dpu['CODE2ERROR']
            
            message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '25B-'
        except: 
            message2print = "{(Step 25Z1/70) yielded" + "; code2error-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '25Z1-'
                            
    if 'QUEUE' not in keys2task: 
        try:
            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - REQUIRED                          
            # ---------------------------------------------------------------------------------------------         
            queue2dpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2dpu-trying-by-create2kernel4dpu: " + str(queue2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2dpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2dpu-got-by-create2kernel4dpu: " + str(queue2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2dpu-failed-by-create2kernel4dpu: " + str(queue2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2dpu ['QUEUE'] = queue2dpu
        except:
            message2print = "{(Step 26Z1/70) yielded" + "; queue-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z1-'             

    if 'QUEUE' in keys2task:          
        message2print = "{(Step 26A/70) try" + "; queue-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 26/70) - QUEUE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dpu2kernel4xi['QUEUE'] = task4kernel2dpu['QUEUE']
            
            message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x0000000003E72828> 
            
            code2ack  = code2ack + '26B-'
        except: 
            message2print = "{(Step 26Z2/70) yielded" + "; queue-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z2-' 
              
    if 'PIPE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------         
            pipe2dpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2dpu-trying-by-create2kernel4dpu: " + str(pipe2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2dpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2dpu-got-by-create2kernel4dpu: " + str(pipe2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2dpu-failed-by-create2kernel4dpu: " + str(pipe2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2dpu ['PIPE'] = pipe2dpu 
        except: 
            message2print = "{(Step 27Z1/70) yielded" + "; pipe-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z1-'
                                 
    if 'PIPE' in keys2task:                                
        message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 27/70) - PIPE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            dpu2kernel4xi['PIPE'] = task4kernel2dpu['PIPE']
            
            message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
            
            code2ack  = code2ack + '27B-'
        except: 
            message2print = "{(Step 27Z2/70) yielded" + "; pipe-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z2-' 

    if 'COMMANDQUEUE' in keys2task:
        message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2kernel4dpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (28) COMMAND QUEUE - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            dpu2kernel4xi['COMMANDQUEUE']  = task4kernel2dpu['COMMANDQUEUE']  
     
            message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                    
            code2ack  = code2ack + '28B-'
        except: 
            message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
                  
            code2nack  = code2nack + '28Z1-'    
    
    if 'BUFFER' in keys2task:
        message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2kernel4dpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (29) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            dpu2kernel4xi['BUFFER']  = task4kernel2dpu['BUFFER']  
     
            message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
            
            
            code2ack  = code2ack + '29B-'
        except: 
            message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '29Z1-'            
    
    if 'EVENT' in keys2task:
        message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2kernel4dpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            dpu2kernel4xi['EVENT']  = task4kernel2dpu['EVENT']  
     
            message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'DATA2CALLBACK' ... 
            
            code2ack  = code2ack + '30B-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '30Z1-'
                        
    
    if 'COUNT4PY' in keys2task:               
        message2print = "{(Step 31A1/70) try" + "; count2py4dpu-try-by-create2kernel4dpu: " + str(task4kernel2dpu['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PY - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['COUNT4PY']  = task4kernel2dpu['COUNT4PY']  
    
            message2print = "{(Step 31A2/70) initialized" + "; count2py4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31A2-'
        except: 
            message2print = "{(Step 31Z1/70) yielded" + "; count2py4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z1-'     
    
    if 'COUNT4CPP' in keys2task:               
        message2print = "{(Step 31B1/70) try" + "; count2cpp4dpu-try-by-create2kernel4dpu: " + str(task4kernel2dpu['COUNT4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CPP - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['COUNT4CPP']  = task4kernel2dpu['COUNT4CPP']  
    
            message2print = "{(Step 31B2/70) initialized" + "; count2cpp4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['COUNT4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31B2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cpp4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
            
    
    if 'COUNT4C' in keys2task:               
        message2print = "{(Step 31C1/70) try" + "; count2c4dpu-try-by-create2kernel4dpu: " + str(task4kernel2dpu['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4C - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['COUNT4C']  = task4kernel2dpu['COUNT4C']  
    
            message2print = "{(Step 31C2/70) initialized" + "; count2c4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31C2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2c4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
    
    if 'COUNT4CL' in keys2task:               
        message2print = "{(Step 31D1/70) try" + "; count2cl4dpu-try-by-create2kernel4dpu: " + str(task4kernel2dpu['COUNT4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CL - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['COUNT4CL']  = task4kernel2dpu['COUNT4CL']  
    
            message2print = "{(Step 31D2/70) initialized" + "; count2cl4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['COUNT4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31D2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cl4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
                
    if 'COUNT4PYC' in keys2task:               
        message2print = "{(Step 31E1/70) try" + "; count4pyc-try-by-create2kernel4dpu: " + str(task4kernel2dpu['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PYC - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['COUNT4PYC']  = task4kernel2dpu['COUNT4PYC']  
    
            message2print = "{(Step 31E2/70) initialized" + "; count4pyc-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31E2-'
        except: 
            message2print = "{(Step 31Z4/70) yielded" + "; count4pyc-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z4-'     
    
    if 'COUNT4BIN' in keys2task:               
        message2print = "{(Step 31F1/70) try" + "; count4bin-try-by-create2kernel4dpu: " + str(task4kernel2dpu['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4BIN - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['COUNT4BIN']  = task4kernel2dpu['COUNT4BIN']  
    
            message2print = "{(Step 31F2/70) initialized" + "; count4bin-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 0
            code2ack  = code2ack + '31F2-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count4bin-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z5-' 
                            
    if 'DIRECTORY4PY' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A) DIRECTORY4PY - REQUIRED                
            # ---------------------------------------------------------------------------------------------             
            dir2py4dpu = folder2lib4dpu                                                                                                                                                            
            message2print = "{(Step 32A/70) set" + "; dir2py4dpu-set-by-create2kernel4dpu to: " + str(dir2py4dpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu 
            code2ack  = code2ack + '32A-' 
        
            task4kernel2dpu ['DIRECTORY4PY'] = dir2py4dpu
        except: 
            message2print = "{(Step 32AZ/70) yielded" + "; directory4py-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32AZ-'                         
               
    if 'DIRECTORY4PY' in keys2task:
        message2print = "{(Step 32A1/70) try" + "; directory4py-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PY - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['DIRECTORY4PY']  = task4kernel2dpu['DIRECTORY4PY']  
     
            message2print = "{(Step 32B1/70) initialized" + "; directory2py4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z1/70) yielded" + "; directory2py4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CPP' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CPP - C++                 
            # ---------------------------------------------------------------------------------------------             
            dir2cpp4dpu = folder2lib4dpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cpp4dpu-set-by-create2kernel4dpu to: " + str(dir2cpp4dpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2dpu ['DIRECTORY4CPP'] = dir2cpp4dpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CPP' in keys2task:
        message2print = "{(Step 32A2/70) try" + "; directory2cpp4dpu-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CPP - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['DIRECTORY4CPP']  = task4kernel2dpu['DIRECTORY4CPP']  
     
            message2print = "{(Step 32B2/70) initialized" + "; directory2cpp4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dpu
            code2ack  = code2ack + '32B2-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2cpp4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
                         
    if 'DIRECTORY4C' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4C - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2c4dpu = folder2lib4dpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2c4dpu-set-by-create2kernel4dpu to: " + str(dir2c4dpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2dpu ['DIRECTORY4C'] = dir2c4dpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4C' in keys2task:
        message2print = "{(Step 32A3/70) try" + "; directory2c4dpu-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4C - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['DIRECTORY4C']  = task4kernel2dpu['DIRECTORY4C']  
     
            message2print = "{(Step 32B3/70) initialized" + "; directory2c4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['DIRECTORY4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2c4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CL' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CL - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2cl4dpu = folder2lib4dpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cl4dpu-set-by-create2kernel4dpu to: " + str(dir2cl4dpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2dpu ['DIRECTORY4CL'] = dir2cl4dpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CL' in keys2task:
        message2print = "{(Step 32A4/70) try" + "; directory2cl4dpu-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CL - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['DIRECTORY4CL']  = task4kernel2dpu['DIRECTORY4CL']  
     
            message2print = "{(Step 32B4/70) initialized" + "; directory2cl4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['DIRECTORY4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z4/70) yielded" + "; directory2cl4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-'
              
    if 'DIRECTORY4PYC' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4PYC - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4dpu = folder2lib4dpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 32B2/70) set" + "; dir2pycache4dpu-set-by-create2kernel4dpu to: " + str(dir2pycache4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu + '__pycache__//'
            code2ack  = code2ack + '32B2-' 
        
            task4kernel2dpu ['DIRECTORY4PYC'] = dir2pycache4dpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'                     
                                                    
    if 'DIRECTORY4PYC' in keys2task:
        message2print = "{(Step 32C/70) try" + "; directory2pyc4dpu-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PYC - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['DIRECTORY4PYC']  = task4kernel2dpu['DIRECTORY4PYC']  
     
            message2print = "{(Step 32D/70) initialized" + "; directory2pyc4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dpu + __pycache__//
            code2ack  = code2ack + '32D-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z2-' 
             
    if 'DIRECTORY4BIN' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4BIN - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2bin4dpu = folder2lib4dpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4dpu-set-by-create2kernel4dpu to: " + str(dir2bin4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4dpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2dpu ['DIRECTORY4BIN'] = dir2bin4dpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4bin-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-' 
                                        
    if 'DIRECTORY4BIN' in keys2task:
        message2print = "{(Step 32E/70) try" + "; directory2bin4dpu-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4BIN - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['DIRECTORY4BIN']  = task4kernel2dpu['DIRECTORY4BIN']  
     
            message2print = "{(Step 32F/70) initialized" + "; directory2bin4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4dpu + bin//
            code2ack  = code2ack + '32F-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2bin4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z3-'  
    
                     
    if 'CODE4PY' in keys2task:            
        message2print = "{(Step 33A1/70) try" + "; code2py4dputask-try-by-create2kernel4dpu: " + str(task4kernel2dpu ['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dpu + 'dpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: ...
        
        dpu2kernel4xi['CODE4PY'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PY - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['CODE4PY'] = task4kernel2dpu ['CODE4PY']
    
     
            message2print = "{(Step 33B1/70) created" + "; code2py4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 'dpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2:
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z1/70) yielded" + "; code2py4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4PY']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2py4dpu2nack  = code2py4dpu2nack + '33Z1-'     
                     
    if 'CODE4CPP' in keys2task:            
        message2print = "{(Step 33A2/70) try" + "; code2cpp4dputask-try-by-create2kernel4dpu: " + str(len(task4kernel2dpu ['CODE4CPP']))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dpu +  dpu2dummy4xi5test.cpp
        
        dpu2kernel4xi['CODE4CPP'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CPP - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['CODE4CPP'] = task4kernel2dpu ['CODE4CPP']
    
     
            message2print = "{(Step 33B2/70) created" + "; code2cpp4dpu-created-by-create2kernel4dpu: " + str(len(dpu2kernel4xi['CODE4CPP']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + dpu2dummy4xi5test.cpp
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2cpp4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4CPP']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cpp4dpu2nack  = code2cpp4dpu2nack + '33Z2-'     
                     
    if 'CODE4C' in keys2task:            
        message2print = "{(Step 33A3/70) try" + "; code2c4dputask-try-by-create2kernel4dpu: " + str(task4kernel2dpu ['CODE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dpu + 
        
        dpu2kernel4xi['CODE4C'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4C - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['CODE4C'] = task4kernel2dpu ['CODE4C']
    
     
            message2print = "{(Step 33B3/70) created" + "; code2c4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2c4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4C']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2c4dpu2nack  = code2c4dpu2nack + '33Z3-'                             
                     
    if 'CODE4CL' in keys2task:            
        message2print = "{(Step 33A4/70) try" + "; code2cl4dputask-try-by-create2kernel4dpu: " + str(task4kernel2dpu ['CODE4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dpu + 
        
        dpu2kernel4xi['CODE4CL'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CL - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['CODE4CL'] = task4kernel2dpu ['CODE4CL']
    
     
            message2print = "{(Step 33B4/70) created" + "; code2cl4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z4/70) yielded" + "; code2cl4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4CL']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cl4dpu2nack  = code2cl4dpu2nack + '33Z1-'     
                                        
    if 'CODE4PYC' in keys2task:            
        message2print = "{(Step 33C/70) try" + "; code2pyc4dpu-try-by-create2kernel4dpu: " + str(task4kernel2dpu ['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dpu + 
        
        dpu2kernel4xi['CODE4PYC'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['CODE4PYC'] = task4kernel2dpu ['CODE4PYC']
    
     
            message2print = "{(Step 33D/70) created" + "; code2pyc4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 
             
            code2ack  = code2ack + '33D-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2pyc4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4PYC']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2pyc4dpu2nack  = code2pyc4dpu2nack + '33Z2-'     
                            
    if 'CODE4BIN' in keys2task:            
        message2print = "{(Step 33E/70) try" + "; code2bin4dpu2bin4dpu-try-by-create2kernel4dpu: " + str(task4kernel2dpu ['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4dpu + 
        
        dpu2kernel4xi['CODE4BIN'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['CODE4BIN'] = task4kernel2dpu ['CODE4BIN']
    
     
            message2print = "{(Step 33F/70) created" + "; code2bin4dpu-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 
             
            code2ack  = code2ack + '33F-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2bin4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi['CODE4BIN']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2bin4dpu2nack  = code2bin4dpu2nack + '33Z3-'     
            
    if 'SIZE4PY' in keys2task:        
        message2print = "{(Step 34A1/70) try" + "; size2py4dpu-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['SIZE4PY']  = task4kernel2dpu['SIZE4PY']  
     
            message2print = "{(Step 34B1/70) initialized" + "; size2py4dpu-initialized-by-create2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 'dpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z1/70) yielded" + "; size2py4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
            
    if 'SIZE4CPP' in keys2task:        
        message2print = "{(Step 34A2/70) try" + "; size2cpp4dpu-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['SIZE4CPP']  = task4kernel2dpu['SIZE4CPP']  
     
            message2print = "{(Step 34B2/70) initialized" + "; size2cpp4dpu-initialized-by-create2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + dpu2dummy4xi5test.cpp': 333}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z2/70) yielded" + "; size2cpp4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4C' in keys2task:        
        message2print = "{(Step 34A3/70) try" + "; size2c4dpu-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['SIZE4C']  = task4kernel2dpu['SIZE4C']  
     
            message2print = "{(Step 34B3/70) initialized" + "; size2c4dpu-initialized-by-create2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size2c4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4CL' in keys2task:        
        message2print = "{(Step 34A4/70) try" + "; size2cl4dpu-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['SIZE4CL']  = task4kernel2dpu['SIZE4CL']  
     
            message2print = "{(Step 34B4/70) initialized" + "; size2cl4dpu-initialized-by-create2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size2cl4dpu-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
                                    
                        
    if 'SIZE4PYC' in keys2task:        
        message2print = "{(Step 34E/70) try" + "; size-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34F) SIZE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['SIZE4PYC']  = task4kernel2dpu['SIZE4PYC']  
     
            message2print = "{(Step 34F/70) initialized" + "; size-initialized-by-create2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 
            code2ack  = code2ack + '34F-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z3-'     
            
    if 'SIZE4BIN' in keys2task:        
        message2print = "{(Step 34G/70) try" + "; size-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34G) SIZE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            dpu2kernel4xi['SIZE4BIN']  = task4kernel2dpu['SIZE4BIN']  
     
            message2print = "{(Step 34H/70) initialized" + "; size-initialized-by-create2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4dpu + 
            code2ack  = code2ack + '34H-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z4-'
                 
    if 'LANGUAGE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (35A0) LANGUAGE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dpu ['LANGUAGE'] = {}
            
            for key2code4dpu in keys2code4dpu:
                name2program4dpu=os.path.splitext(key2code4dpu)                                                     
                key2extension4dpu = name2program4dpu[1]                                                             
                if key2extension4dpu == '.py':                          
                    task4kernel2dpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4dpu == '.cpp':                          
                    task4kernel2dpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4dpu == '.c':                          
                    task4kernel2dpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4dpu == '.cl':                          
                    task4kernel2dpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4dpu-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-' 
        except: 
            message2print = "{(Step 35Z0/70) yielded" + "; language-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z0-'
                                     
    if 'LANGUAGE' in keys2task:        
        message2print = "{(Step 35A/70) try" + "; language-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (35) LANGUAGE - PYTHON, C++, C, CL                              
            # ---------------------------------------------------------------------------------------------             
                            
            dpu2kernel4xi['LANGUAGE']  = task4kernel2dpu['LANGUAGE']  
     
            message2print = "{(Step 35B/70) initialized" + "; language-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-'
        except: 
            message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z1-'  
                     
    if 'COUNT2REFERENCE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (36A0) COUNT2REFERENCE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            count2reference2dpu  = 1
           
            message2print = "{(Step 36B/70) set" + "; count2reference2dpu-set-by-create2kernel4dpu to: " + str(count2reference2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '36B-' 
        
            task4kernel2dpu ['COUNT2REFERENCE'] = count2reference2dpu     
        except: 
            message2print = "{(Step 36Z0/70) yielded" + "; count2reference2dpu-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z0-'             
                
    if 'COUNT2REFERENCE' in keys2task:                
        message2print = "{(Step 36A/70) try" + "; count2reference-try-by-create2kernel4dpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (36) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            dpu2kernel4xi['COUNT2REFERENCE']  = task4kernel2dpu['COUNT2REFERENCE']  
     
            message2print = "{(Step 36B/70) initialized" + "; count2reference-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '36B-'
        except: 
            message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z1-' 
                
    if 'PROGRAM' not in keys2task:
        message2print = "{(Step 37/70) warned" + "; keys2task4program-warned-by-create2kernel4dpu: " + " ** " + str(keys2task)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:             
            # ---------------------------------------------------------------------------------------------
            # (37A0) PROGRAM - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2dpu ['PROGRAM'] = None
            message2print = "{(Step 37A/70) try" + "; program2dpu-try-by-create2kernel4dpu: " + str(task4kernel2dpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2dpu ['PROGRAM'] = create2programwithsource4dpu()
                keys2program = task4kernel2dpu ['PROGRAM'].keys()
                
                message2print = "{(Step 37B/70) set" + "; program-set-by-create2kernel4dpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'PROGRAM', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '37B-'
            except:
                message2print = "{(Step 37Z1/70) failed" + "; task4kernel2dpu-failed-by-create2kernel4dpu: " + str(task4kernel2dpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '37Z-'    
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; program-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-' 
                            
    if 'PROGRAM' in keys2task:
        message2print = "{(Step 37A/70) try" + "; program-try-by-create2kernel4dpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (37) PROGRAM - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            dpu2kernel4xi['PROGRAM']  = task4kernel2dpu['PROGRAM']  
     
            message2print = "{(Step 37B/70) initialized" + "; program-created-by-create2kernel4dpu: " + str(len(dpu2kernel4xi['PROGRAM']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0 ... 
            
            code2ack  = code2ack + '37B-'
        except: 
            message2print = "{(Step 37Z1/70) yielded" + "; program-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z1-' 
                       
    if 'FUNCTION' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2dpu ['FUNCTION'] = {}
            message2print = "{(Step 38A0/70) set" + "; function4dpu-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2dpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 38A1/70) set" + "; pythonfunction4dpu-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4dpu  = kb2kernel4dpu ['.py'] ['TAG']
            message2print = "{(Step 38A2/70) using" + "; tag2search4dpu-using-by-create2kernel4dpu: " + str(tag2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4dpu    = kb2kernel4dpu ['.py'] ['VALUE']
            message2print = "{(Step 38A3/70) using" + "; value2search4dpu-using-by-create2kernel4dpu: " + str(value2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # dpu2sampler4xi5test
            
            attribute2search4dpu= kb2kernel4dpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 38A4/70) using" + "; attribute2search4dpu-using-by-create2kernel4dpu: " + str(attribute2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4dpu in keys2code4dpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4dpu]
                    keys2line4dpu = code2examine4dpu.keys()
                    for key2line4dpu in keys2line4dpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4dpu] [key2line4dpu]
                        # message2print = "{(Step 38A5/70) examining" + "; line2examine4dpu-examining-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4dpu,tag2search4dpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 38B/70) examining" + "; line2function4dpu-examining-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # function = "dpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4dpu,value2search4dpu)
                            if index2function == -1:
                                message2print = "{(Step 38C/70) skipped" + "; line2function4dpu-skipped-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "set2trace4sampler" ... # function = "dpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4dpu,attribute2search4dpu)             # ....function = "dpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 38D/70) warning" + "; line2function4dpu-warning-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 38E/70) accepted" + "; line2examine4dpu-accepted-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ... function = "dpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4dpu = line2examine4dpu[index2function:index2usage-2]
                                    
                                    task4kernel2dpu ['FUNCTION'] ['.py'] [key2pythonfunction4dpu] = {}                                  

                                    message2print = "{(Step 38F/70) used" + "; key2pythonfunction4dpu-used-by-create2kernel4dpu: " + str(key2pythonfunction4dpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # dpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '38F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 38Z1/70) failed" + "; task4kernel2dpu-failed-by-create2kernel4dpu: " + str(task4kernel2dpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '38Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (39) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2dpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 39A0F/70) set" + "; cplusfunction4dpu-set-by-create2kernel4dpu to: " + str(task4kernel2dpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4dpu      = kb2kernel4dpu ['.cpp'] ['TAG']
            message2print = "{(Step 39A2/70) using" + "; tag2search4dpu-using-by-create2kernel4dpu: " + str(tag2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # function =
            
            attribute2search4dpu= kb2kernel4dpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 39A4/70) using" + "; attribute2search4dpu-using-by-create2kernel4dpu: " + str(attribute2search4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4dpu in keys2code4dpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4dpu]
                    message2print = "{(Step 39A5/70) using" + "; key2code4dpu-using-by-create2kernel4dpu: " + str(key2code4dpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # dpu2dummy4xi5test.cpp
                       
                    keys2line4dpu = code2examine4dpu.keys()
                    # message2print = "{(Step 39A6/70) using" + "; keys2line4dpu-using-by-create2kernel4dpu: " + str(keys2line4dpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4dpu in keys2line4dpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4dpu = task4kernel2dpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4dpu] [key2line4dpu]
                        # message2print = "{(Step 39A7/70) examining" + "; line2examine4dpu-examining-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # function = "nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4dpu,tag2search4dpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 39B1/70) examining" + "; line2function4dpu-examining-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # function = "OCLError" usage = "error code checking"*/
                            # function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 39B2/70) using" + "; attribute2search4dpu-using-by-create2kernel4dpu: " + str(attribute2search4dpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4dpu,attribute2search4dpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 39C/70) skipped" + "; line2function4dpu-skipped-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 39E/70) accepted" + "; line2examine4dpu-accepted-by-create2kernel4dpu: " + str(line2examine4dpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "nbody_kern" usage = "kernel example 1"*/; 
                                # function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4dpu = line2examine4dpu[27:index2usage-2]  
                                task4kernel2dpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4dpu] =  {}                                       

                                message2print = "{(Step 39F/70) used" + "; key2kernelfunction4dpu-used-by-create2kernel4dpu: " + str(key2kernelfunction4dpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '39F-'
                                    
            except: 
                message2print = "{(Step 37Z1/70) yielded" + "; program-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + '37Z1-'
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; function-dpu2kernel4xi-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-'                               
                
    if 'FUNCTION' in keys2task:    
        message2print = "{(Step 38A/70) trying" + "; function-trying-by-create2kernel4dpu: " + str(task4kernel2dpu['FUNCTION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'.py': {'dpu2sampler4xi5test': {}}, 
        # '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}    
        try:            
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            dpu2kernel4xi['FUNCTION']  = task4kernel2dpu['FUNCTION']   
     
            message2print = "{(Step 38B/70) created" + "; function-created-by-create2kernel4dpu: " + str(dpu2kernel4xi['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'.py': {'dpu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}} 
            
            code2ack  = code2ack + '38B-'
        except: 
            message2print = "{(Step 38Z1/70) yielded" + "; function-yielded-by-create2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '38Z1-'            
                                       
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)     
    # -----------------------------------------------------------------------------------------
    dpu2kernel4xi ['ACK2RETURN']  = code2ack
    dpu2kernel4xi ['NACK2RETURN'] = code2nack 
     
    keys2kernel4dpu = dpu2kernel4xi.keys()
    message2print = "{(Step 70A/70) returning" + "; keys2kernel4dpu-returning-by-create2kernel4dpu: " + str(keys2kernel4dpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 (no parameters given by caller): 
    # ['DIRECTORY4CL',
    #  'DIRECTORY4PY',
    #  'DIRECTORY4C',
    #  'DIRECTORY4CPP',
    #  'DIRECTORY4PYC',    
    #  'DIRECTORY4BIN',    
    #  'CODE4PY',
    #  'CODE4PYC',
    #  'CODE4CPP',
    #  'CODE4BIN',
    #  'CODE4C',
    #  'CODE4CL',
    #  'COUNT4C',                
    #  'COUNT4CL',    
    #  'COUNT4CPP',
    #  'COUNT4PYC',
    #  'COUNT4PY',
    #  'COUNT4BIN',
    #  'SIZE4PY',    
    #  'SIZE4CPP', <-- OK: C and CL MISSING
    #  'SIZE4PYC',
    #  'SIZE4BIN',
                        
    #  'QUEUE',
    #  'PROGRAM',
    #  'CONTEXT',
    #  'PIPE',
    #  'FUNCTION2CALLBACK',
    #  'COMMANDQUEUE',
    #  'PLATFORM',
    #  'FUNCTION',
    #  'CODE2ERROR',
    #  'ACK2RETURN',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'COUNT2REFERENCE',
    #  'DEVICE',
    #  'LANGUAGE',
    #  'NACK2RETURN',
    #  'EVENT']



    
    #2 (function and program parameters given by user):
    # ['FUNCTION',
    #  'ACK2RETURN',
    #  'PROGRAM',
    #  'NACK2RETURN']

    
    keys2programkernel4dpu = dpu2kernel4xi['PROGRAM'].keys()
    message2print = "{(Step 70B/70) returning" + "; keys2programkernel4dpu-returning-by-create2kernel4dpu: " + str(keys2programkernel4dpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 and 2:
    # ['CODE2ERROR', 'LANGUAGE4SOURCE', 'COUNT4SOURCE' ...
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2py4dpu-returning-by-create2kernel4dpu: " + str(dpu2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2cpp4dpu-returning-by-create2kernel4dpu: " + str(dpu2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2c4dpu-returning-by-create2kernel4dpu: " + str(dpu2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cl4dpu-returning-by-create2kernel4dpu: " + str(dpu2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2py4dpu-returning-by-create2kernel4dpu: " + str(dpu2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # pu2sampler4xi5test.py': 1337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2cpp4dpu-returning-by-create2kernel4dpu: " + str(dpu2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # dpu2dummy4xi5test.cpp': 331
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2c4dpu-returning-by-create2kernel4dpu: " + str(dpu2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cl4dpu-returning-by-create2kernel4dpu: " + str(dpu2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    


    message2print = "{(Step 70T/70) returning" + "; function2kernel4dpu-returning-by-create2kernel4dpu: " + str(dpu2kernel4xi['FUNCTION']) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # {'.py':  {'dpu2sampler4xi5test': {}},
    #  '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}
    # }  
        
    
                         
    return dpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2kernel4dpu" usage = "
#     
#   print('(Step 3A2/700) OF DPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4add2kernel = {}
#       task4add2kernel ['CODE4KERNEL'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4dpu + 'dpu2dummy4xi.py'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4dpu + 'dpu2dummy4xi.py'] [1] = '... profile = "11" />'
#       task4add2kernel ['SIZE4KERNEL'] = {}
#       task4add2kernel ['SIZE4KERNEL'] [folder2lib4dpu + 'dpu2dummy4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4dpu + 'dpu2dummy4xi.py'])
#       
#       response4add2kernel = add2kernel4dpu(task4add2kernel)
#       print('(Step 3A3/700) OF DPU2KERNEL4XI5TEST - ADDED KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z2/700) OF DPU2KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel: ', response4add2kernel)
#          
#">

# -------------------------------------------------------------------------------------------------   
def add2kernel4dpu(task4kernel2dpu):

    '''
    adds to kernel for DPU
    '''
    global dpu2kernel4xi                                                                                            # Kernel of DPU    
    global folder2lib4dpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "add2kernel4dpu" 
    method2print = "add2kernel4dpu"

    message2print = "{(Step 10A/70) started" + "; add2kernel4dpu-started: " + str(add2kernel4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2dpu-to-add2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
    code2ack  = ' '
    code2nack = ' ' 
    try:
        keys2kernel4task = task4kernel2dpu ['CODE4KERNEL'].keys()
        message2print = "{(Step 10C/70) using" + "; keys2kernel4task-using-by-add2kernel4dpu: " + str(keys2kernel4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #         
    except: 
        message2print = "{(Step 10Z1/70) failed" + "; keys2kernel4task-failed-by-add2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    try:
        keys2exist4task =  dpu2kernel4xi ['CODE4KERNEL'].keys() 
        message2print = "{(Step 10D/70) using" + "; keys2exist4task-using-by-add2kernel4dpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    except:
        try:
            response2createwb4dpu = create2kernelsinkernel4dpu()
            keys2createwb4dpu = response2createwb4dpu.keys()
            for key2createwb4dpu in keys2createwb4dpu:
                if key2createwb4dpu == 'CODE4KERNEL':
                    message2print = "{(Step 10E/70) created" + "; key2createwb4dpu-created-by-add2kernel4dpu: " + str(key2createwb4dpu) + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)
                    # 
            
            keys2exist4task =  dpu2kernel4xi ['CODE4KERNEL'].keys() 
            message2print = "{(Step 10F/70) using" + "; keys2exist4task-using-by-add2kernel4dpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        
        except: 
            message2print = "{(Step 10Z2/70) failed" + "; dpu2kernel4xi-failed-by-add2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - EXPECTED - SEVERAL KERNEL CODE CAN BE ADDED INTO ONE PROGRAM OBJECT                              
        # ---------------------------------------------------------------------------------------------             
        for key2kernel4task in keys2kernel4task:
            try:
                message2print = "{(Step 33A/70) using" + "; key2kernel4task-using-by-add2kernel4dpu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                            
                if key2kernel4task in keys2exist4task:
                    message2print = "{(Step 33Z0/70) yielded" + "; key2kernel4task-yielded-by-add2kernel4dpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # folder2lib4dpu +  
                     
                    code2nack  = code2nack + '33Z0-'
                else: 
                    try:
                        dpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task] = task4kernel2dpu ['CODE4KERNEL'] [key2kernel4task]
                    except:
                        message2print = "{(Step 33Z1/70) failed" + "; task4kernel2dpu-failed-by-add2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z1-' 
                    try:             
                        message2print = "{(Step 33B/70) added" + "; key2kernel4task-added-by-add2kernel4dpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        #folder2lib4dpu +  
                    except:
                        message2print = "{(Step 33Z2/70) failed" + "; task4kernel2dpu-failed-by-add2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z2-' 
                    try:             
                        message2print = "{(Step 33C/70) added" + "; code-added-by-add2kernel4dpu to: " + str(dpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z3/70) failed" + "; task4kernel2dpu-failed-by-add2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        code2nack  = code2nack + '33Z3-'                 
                    try:
                        dpu2kernel4xi ['COUNT4KERNEL'] = dpu2kernel4xi ['COUNT4KERNEL'] + 1
                        message2print = "{(Step 33D/70) added" + "; count4kernel-added-by-add2kernel4dpu to: " + str(dpu2kernel4xi ['COUNT4KERNEL'])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z4/70) failed" + "; task4kernel2dpu-failed-by-add2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z4-' 
                    try:                            
                        dpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task]  = task4kernel2dpu['SIZE4KERNEL'] [key2kernel4task]  
                        message2print = "{(Step 33E/70) set" + "; size4kernel-set-by-add2kernel4dpu to: " + str(dpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                        code2ack  = code2ack + '33D-'
                    except:
                        message2print = "{(Step 33Z5/70) failed" + "; task4kernel2dpu-failed-by-add2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z5-'    
            except:
                message2print = "{(Step 33Z6/70) failed" + "; task4kernel2dpu-failed-by-add2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                code2nack  = code2nack + '33Z6-'                     
    except: 
        message2print = "{(Step 33Z7/70) yielded" + "; kernel-yielded-by-add2kernel4dpu: " + str(dpu2kernel4xi ['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '33Z7-'       
          
                                                                                                                   
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2kernel4xi ['ACK2RETURN']  = code2ack
    dpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernelkernels = dpu2kernel4xi ['CODE4KERNEL'].keys()
    for key2kernelkernel in sorted(keys2kernelkernels):
        message2print = "{(Step 70A/70) got" + "; key2kernelkernel-got-by-add2kernel4dpu: " + str(key2kernelkernel) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        #folder2lib4dpu +  


    keys2kernel4dpu = dpu2kernel4xi.keys()
    for key2kernel4dpu in keys2kernel4dpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4dpu-returning-by-add2kernel4dpu: " + str(key2kernel4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return dpu2kernel4xi
            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2nativekernel4dpu" usage = "
#     
#   print('(Step 2A2/700) OF DPU2KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())           
#   try:
#       response4execute = execute2nativekernel4dpu()
#   except:
#       print('(Step 2Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                      
#          
#">

# -------------------------------------------------------------------------------------------------   
def execute2nativekernel4dpu(task4program2dpu=None):

    '''
    executes native kernel of DPU
    '''
    global dpu2kernel4xi                                                                                            # Kernel of DPU    
    global import2use4dpu                                                                                           # Imports of DPU
    global target2function4dpu                                                                                      # Target function of Process4Xi
    global folder2lib4dpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2nativekernel4dpu" 
    method2print = "execute2nativekernel4dpu"

    message2print = "{(Step 1A/70) started" + "; execute2nativekernel4dpu-started: " + str(execute2nativekernel4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4program2dpu-to-execute2nativekernel4dpu: " + str(task4program2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    kernel2program4dpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
    message2print = "{(Step 1C/70) initialized" + "; kernel2program4dpu-initialized-by-execute2nativekernel4dpu to: " + str(kernel2program4dpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                
    try:             
        if task4program2dpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4program2dpu-yielded-by-execute2nativekernel4dpu: " + str(task4program2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - EXECUTE NATIVE KERNELS INSIDE PROGRAM OBJECT FOR DPU ! 
    # ---------------------------------------------------------------------------------------------    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                            
        # ---------------------------------------------------------------------------------------------             
        keys2kernel4dpu = dpu2kernel4xi['CODE4KERNEL'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2kernel4dpu-using-by-execute2nativekernel4dpu: " + str(keys2kernel4dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        unit4processing = "dpu"
        
        for key2kernel4dpu in keys2kernel4dpu:
            index2search=str.find(key2kernel4dpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2execute = key2kernel4dpu[index2search:]                                                          # dpu2sampler4xi5test.py
                index2search=str.find(target2execute,".py")
                if index2search == -1:
                    pass
                else:
                    target2execute4dpu = target2execute[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2execute4dpu-set-by-execute2nativekernel4dpu to: " + str(target2execute4dpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # 

                    p2kernel4dpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4DPU 
                        # ---------------------------------------------------------------------------------------------    
             
                        try:
                            import2use4dpu.get(target2execute4dpu, handle2error4dpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2execute4dpu-imported-by-execute2nativekernel4dpu: " + str(target2execute4dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4dpu-failed-by-execute2nativekernel4dpu: " + str(import2use4dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2execute4dpu-used-by-execute2nativekernel4dpu: " + str(target2execute4dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4DPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2dpu = Process4Xi(target=target2function4dpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2dpu-created-by-execute2nativekernel4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-1, initial)>
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2dpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2dpu-started-by-execute2nativekernel4dpu: " + str(p2dpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-1
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4dpu = p2dpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-execute2nativekernel4dpu: " + str(status2process4dpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2dpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2dpu-run-by-execute2nativekernel4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-execute2nativekernel4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-execute2nativekernel4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-execute2nativekernel4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2kernel4dpu-failed-by-execute2nativekernel4dpu: " + str(p2kernel4dpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    
            # ---------------------------------------------------------------------------------------------
            # SAVE SOURCE WITHOUT END OF LINES
            # ---------------------------------------------------------------------------------------------        
            keys2lines = dpu2kernel4xi['CODE4KERNEL'][key2kernel4dpu].keys()     
            kernel2program4dpu[key2kernel4dpu] = ""
            for key2line in keys2lines:
                code2add4dpu = dpu2kernel4xi ['CODE4KERNEL'] [key2kernel4dpu] [key2line]
                kernel2program4dpu[key2kernel4dpu] = kernel2program4dpu[key2kernel4dpu] + code2add4dpu.replace("\n","")
        
            message2print = "{(Step 34A/70) saved" + "; lenght-kernel4dpu-saved-by-execute2nativekernel4dpu to: " + str(len(kernel2program4dpu[key2kernel4dpu]))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #     
                
 
        message2print = "{(Step 38A/70) set" + "; lenght-kernel2program4dpu-set-by-execute2nativekernel4dpu to: " + str(len(kernel2program4dpu))  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; kernel-yielded-by-execute2nativekernel4dpu: " + str(dpu2kernel4xi['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2kernel4xi ['ACK2RETURN']  = code2ack
    dpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernel4dpu = kernel2program4dpu.keys()
    for key2kernel4dpu in keys2kernel4dpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dpu-returning-by-execute2nativekernel4dpu: " + str(key2kernel4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        # 
    
    return kernel2program4dpu
            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2kernel4dpu" usage = "
#     
#   print('(Step 3A3/700) OF DPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4delete2kernel = {}
#       task4delete2kernel ['CODE4KERNEL'] = {}
#       task4delete2kernel ['CODE4KERNEL'] [folder2lib4dpu + 'dpu2program4xi.py'] = 'Yes'
#       task4delete2kernel ['SIZE4KERNEL'] = {}
#       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4dpu + 'dpu2program4xi.py'] = 'Yes'
#       
#       response4delete2kernel = delete2kernel4dpu(task4delete2kernel) 
#       print('(Step 3A3/700) OF DPU2KERNEL4XI5TEST - DELETED KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF DPU2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION *** ', time4xi()) 
#          
#">

# -------------------------------------------------------------------------------------------------   
def delete2kernel4dpu(task4kernel2dpu):

    '''
    deletes kernel for DPU
    '''
    global dpu2kernel4xi                                                                                     
    global folder2lib4dpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "delete2kernel4dpu" 
    method2print = "delete2kernel4dpu"

    message2print = "{(Step 10A/70) started" + "; delete2kernel4dpu-started: " + str(delete2kernel4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function delete2kernel4dpu at 0x000000000405CEC8>
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2dpu-to-delete2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 


    code2ack  = ' '
    code2nack = ' '    
    #
    ack4key2kernelkernel = False
    try:
        # ---------------------------------------------------------------------------------------------
        # TASK MUST HAVE BEEN GIVEN BY USER - CONTAINS KERNEL KEYS    
        # ---------------------------------------------------------------------------------------------
        keys2delete4kernel = task4kernel2dpu ['CODE4KERNEL'].keys()        
        message2print = "{(Step 19A/70) using" + "; keys2delete4kernel-using-by-delete2kernel4dpu: " + str(sorted(keys2delete4kernel))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # ---------------------------------------------------------------------------------------------
        # (Step 20A/70) - DELETE KERNEL INSIDE PROGRAM OBJECT FOR DPU ! 
        # ---------------------------------------------------------------------------------------------    
        message2print = "{(Step 20A0/70) try" + "; key-try-by-delete2kernel4dpu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      

        for key2delete4kernel in keys2delete4kernel:
            try:            
                del dpu2kernel4xi ['CODE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20C/70) deleted" + "; code4kernel-deleted-by-delete2kernel4dpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20C-' 
                
                del dpu2kernel4xi ['SIZE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20D/70) deleted" + "; size4kernel-deleted-by-delete2kernel4dpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20D-' 
                
                dpu2kernel4xi ['COUNT4KERNEL'] = dpu2kernel4xi ['COUNT4KERNEL'] - 1
                message2print = "{(Step 20E/70) upgraded" + "; count4kernel-upgraded-by-delete2kernel4dpu: " + str(dpu2kernel4xi ['COUNT4KERNEL'] ) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                #                                
                
            except:
                message2print = "{(Step 20Z1/70) yielded" + "; key2delete4kernel-yielded-by-delete2kernel4dpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                
                code2nack  = code2nack + '20Z1-' 
    except: 
        message2print = "{(Step 20Z0/70) failed" + "; task4kernel2dpu-dpu2kernel4xi-failed-by-delete2kernel4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '20Z0-'    
                                                                                            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2kernel4xi ['ACK2RETURN']  = code2ack
    dpu2kernel4xi ['NACK2RETURN'] = code2nack  
    try:
        keys2kernelkernels = dpu2kernel4xi ['CODE4KERNEL'] .keys()
        for key2kernelkernels in keys2kernelkernels:
            message2print = "{(Step 70A/70) got" + "; key2kernelkernels-got-by-delete2kernel4dpu: " + str(key2kernelkernels) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                              
            #  
    except:
        pass 
               
     
    keys2kernel4dpu = dpu2kernel4xi.keys()
    for key2kernel4dpu in keys2kernel4dpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4dpu-returning-by-delete2kernel4dpu: " + str(key2kernel4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 


    return dpu2kernel4xi
            
#</function4xi> 
 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernelsinprogram4dpu" usage = "
#     
#   print('(Step 3A1/700) OF DPU2KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR DPU ', time4xi())          
#   try:
#       response4create2kernelsinprogram = create2kernelsinprogram4dpu()
#       print('(Step 3A2/700) OF DPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR DPU ', time4xi())
#   except:
#       print('(Step 3Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR DPU *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def create2kernelsinprogram4dpu(task4kernel2dpu=None):

    '''
    creates kernels in program for DPU
    '''
    global dpu2kernel4xi                                                                                            # Kernel of DPU    
    global folder2lib4dpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernelsinprogram4dpu" 
    method2print = "create2kernelsinprogram4dpu"

    message2print = "{(Step 1A/70) started" + "; create2kernelsinprogram4dpu-started: " + str(create2kernelsinprogram4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2dpu-to-create2kernelsinprogram4dpu: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    

    
    keys2kernel4dpu = dpu2kernel4xi.keys()
    for key2kernel4dpu in keys2kernel4dpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dpu-returning-by-create2kernelsinprogram4dpu: " + str(key2kernel4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return dpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fetch2kernel4dpu" usage = "
#   fetch2kernel4dpu(file2walk)
#"> 
# -------------------------------------------------------------------------------------------------
def fetch2kernel4dpu(program2explore4dpu):
    global fetch2code4dpu                                                                                           # dictionary to receive files 
        
    global kb2fetch4dpu                                                                                             # knowledgebase for fetching
    global profile2fetch                                                                                            # profiles
    global keys2profile4dpu                                                                                         # file extensions 
    
    global folder2lib4dpu  

    class2print  = "fetch2kernel4dpu"
    method2print = "fetch2kernel4dpu" 
     
    message2print = "{(Step 1A/33) passed" + "; program2explore4dpu-passed-to-fetch2kernel4dpu: " + str(program2explore4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # folder2lib4dpu + dpu2buffer4xi.py          ... dpu2sampler4xi5test.py ... dpu2dummy4xi5test.cpp ...           # Python and C++ programs
    # __pycache__\dpu2buffer4xi.cpython-33.pyc   ... dpu2sampler4xi5test.cpython-33.pyc ...                         # Cache of Python binaries
    # //bin\dpu2dummy4xi5test.exe                                                                                   # Built C++ exe files
                  
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program4dpu=os.path.splitext(program2explore4dpu)                                                          # dpu2sampler4xi5test + py

    key2extension4dpu = name2program4dpu[1]                                                                         # py,pyc,cpp,exe 
    message2print = "{(Step 1B/33) set" + "; key2extension4dpu-set-by-fetch2kernel4dpu to: " + str(key2extension4dpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # .py; .pyc
    message2print = "{(Step 1C/33) using" + "; profile2fetch-using-by-fetch2kernel4dpu: " + str(profile2fetch)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # {'.pyc': 'NACK', '.py': 'ACK', '.cpp': 'ACK', '.exe': 'NACK'}  
        
    if profile2fetch [key2extension4dpu] == 'ACK':                                                                  # profile2fetch ['py']  = 'ACK'       
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - EXTENSION IN PROFILE 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore4dpu-analyzing-by-fetch2kernel4dpu: " + str(program2explore4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # folder2lib4dpu +  dpu2buffer4xi.py ; dpu2sampler4xi5test.py ...  ... __pycache__\dpu2sampler4xi5test.cpython-33.pyc
        # dpu2dummy4xi5test.cpp
             
        path2input4dpu = program2explore4dpu
        message2print = "{(Step 1B/33) set" + "; path2input4dpu-set-by-fetch2kernel4dpu to: " + str(path2input4dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # folder2lib4dpu +  dpu2buffer4xi.py ; __pycache__\dpu2sampler4xi5test.cpython-33.pyc; dpu2dummy4xi5test.cpp

        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER PROGRAM MUST BE FETCHED 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A1/33) analyzing" + "; path2input4dpu-analyzing-by-fetch2kernel4dpu: " + str(path2input4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #folder2lib4dpu +  dpu2buffer4xi.py ; dpu2dummy4xi5test.cpp 
            
        keys2fetch4dpu = kb2fetch4dpu.keys()
        message2print = "{(Step 2A2/33) using" + "; keys2fetch4dpu-using-by-fetch2kernel4dpu: " + str(keys2fetch4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #        
        ack2match4file = False
        for key2fecth4dpu in keys2fetch4dpu:                                                                        # 1,2 ...
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------
            index2search=str.find(path2input4dpu,kb2fetch4dpu[key2fecth4dpu])                                       
            if index2search == -1:                                         
                # -----------------------------------------------------------------------------------------
                # VALID FILE TYPE BUT NOT SELECTED TO BE FETCHED - OK ONE MAY ALSO PASS HERE!
                # -----------------------------------------------------------------------------------------               
                message2print = "{(Step 2C1/33) skipped" + "; path2input4dpu-skipped-by-fetch2kernel4dpu: " + str(path2input4dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # folder2lib4dpu +  dpu2buffer4xi.py 
                
            else:
                ack2match4file = True
                
                message2print = "{(Step 2D/33) decided" + "; program-to-read-decided-by-fetch2kernel4dpu: " + str(path2input4dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                #folder2lib4dpu +  dpu2sampler4xi5test.py; __pycache__//dpu2sampler4xi.cpython-33.pyc; 
                #               +  dpu2dummy4xi5test.cpp

                # -----------------------------------------------------------------------------------------
                # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT FILE - READ MODE SET ACCORDING TO FILE TYPE
                # -----------------------------------------------------------------------------------------
                if ((key2extension4dpu == '.py') or (key2extension4dpu == '.cpp') or (key2extension4dpu == '.c') or (key2extension4dpu == '.cl')):
                    file2input4dpu = open(path2input4dpu,'r')
                    message2print = "{(Step 3A/33) opened" + "; file2input4dpu-opened-by-fetch2kernel4dpu: " + str(file2input4dpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # <_io.TextIOWrapper name=folder2lib4dpu + 'dpu2sampler4xi5test.py' mode='r' encoding='cp1252'> 
                     
                if ((key2extension4dpu == '.pyc') or (key2extension4dpu == '.exe')):
                    file2input4dpu = open(path2input4dpu,'rb')
                    message2print = "{(Step 3B/33) opened" + "; file2input4dpu-opened-by-fetch2kernel4dpu: " + str(file2input4dpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    #  __pycache__//dpu2sampler4xi.cpython-33.pyc               
                    
                # -----------------------------------------------------------------------------------------
                # (Step 4/33) OF FETCH2SCOPE4XI - OUTPUT 
                # -----------------------------------------------------------------------------------------
                key2save4dpu = path2input4dpu
                fetch2code4dpu[key2save4dpu] = {}                                                                   # fetch2code4dpu['dpu2sampler4xi5test.py'] = {}
                number2line4dpu = 0  
                message2print = "{(Step 3B/33) saving" + "; key2fecth4dpu-saving-by-fetch2kernel4dpu: " + str(key2fecth4dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
         
                while 1:
                    # -------------------------------------------------------------------------------------
                    # (Step 5/33) OF FETCH2SCOPE4XI - PROCESS FILE
                    # -------------------------------------------------------------------------------------             
                    line2process4dpu = file2input4dpu.readline()  
                    if not line2process4dpu:
                        # ---------------------------------------------------------------------------------
                        # (Step 30/33) OF FETCH2SCOPE4XI - ALL LINES READ, FINISH
                        # ---------------------------------------------------------------------------------             
                        break                                               
                    else:
                        # ---------------------------------------------------------------------------------
                        # (Step 7/33) OF FETCH2SCOPE4XI - SAVE LINE
                        # ---------------------------------------------------------------------------------
                        # message2print = "{(Step 7A/33) read" + "; line2process4dpu-read-by-fetch2kernel4dpu: " + str(line2process4dpu) + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print)              
                        # ... profile = "11" />
                        # ...
                        # # end of dpu2sampler4xi5test.py 
                        # #/> 
                        try:
                            number2line4dpu = number2line4dpu + 1
                            fetch2code4dpu[key2save4dpu][number2line4dpu] = line2process4dpu
                        except:
                            message2print = "{(Step 7Z1/33) failed" + "; key2fecth4dpu-failed-by-fetch2kernel4dpu: " + str(key2fecth4dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z2/33) failed" + "; line2process4dpu-failed-by-fetch2kernel4dpu: " + str(line2process4dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z3/33) failed" + "; number2line4dpu-failed-by-fetch2kernel4dpu: " + str(number2line4dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                                                             
                # -----------------------------------------------------------------------------------------
                # (Step 31/33) OF FETCH2SCOPE4XI - CLOSE INPUT
                # -----------------------------------------------------------------------------------------            
                file2input4dpu.close()
                message2print = "{(Step 31A/33) closed" + "; file2input4dpu-closed-by-fetch2kernel4dpu: " + str(file2input4dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name=folder2lib4dpu + 'dpu2sampler4xi5test.py' mode='r' encoding='cp1252'>     # Python source files
                # {folder2lib4dpu + 'dpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: '# -- 
                # dpu2dummy4xi5test.cpp                                                                             # C++ source files
                # __pycache__//dpu2sampler4xi.cpython-33.pyc                                                        # Cached binary files of Python
                # dpu2dummy4xi5test.exe                                                                             # C++ exe files
        
                message2print = "{(Step 31B1/33) saved" + "; fetch2code4dpu-saved-by-fetch2kernel4dpu: " + str(fetch2code4dpu[key2save4dpu] [1]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... profile = "11" />
                
                message2print = "{(Step 31B2/33) saved" + "; fetch2code4dpu-saved-by-fetch2kernel4dpu: " + str(fetch2code4dpu[key2save4dpu] [2]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # dpu2dummy4xi5test.cpp
                
                message2print = "{(Step 31B3/33) saved" + "; fetch2code4dpu-saved-by-fetch2kernel4dpu: " + str(fetch2code4dpu[key2save4dpu] [3]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... program = "dpu2sampler4xi5test.py">
                
                message2print = "{(Step 31B4/33) saved" + "; fetch2code4dpu-saved-by-fetch2kernel4dpu: " + str(fetch2code4dpu[key2save4dpu] [4]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ...  abstract = "tests dpu2sampler4xi.py"/>
                                                                 
                # ---------------------------------------------------------------------------------------------
                #
                # ---------------------------------------------------------------------------------------------                                          


    else:
        # -----------------------------------------------------------------------------------------
        # FILE TYPE - NOT IN PROFILE
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 1F/33) skipped" + "; name2program4dpu-skipped-by-fetch2kernel4dpu: " + str(name2program4dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # folder2lib4dpu + '__pycache__//dpu2buffer4xi.cpython-32', '.pyc')
        
        extension2skip = name2program4dpu[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-fetch2kernel4dpu: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc

        message2print = "{(Step 1H/33) returning" + "; fetch2kernel4dpu-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
 
    message2print = "{(Step 1H/33) returning" + "; fetch2kernel4dpu-returning: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)            
    #   
                                            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernel4dpu" usage = "
#
#   ... prepare task4set2kernelws ...    
#
#   response4set2kernel = {} 
#   print('(Step 17F/700) OF DPU2KERNEL4XI5TEST - TRYING TO SET KERNEL: ', set2kernel4dpu)   
#   # 
#   try:                               
#       response4set2kernel = set2kernel4dpu(task4set2kernelws)
#       print('(Step 17G/700) OF DPU2KERNEL4XI5TEST - SET KERNEL: ', response4set2kernel)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF DPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL: ', set2kernel4dpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernel4dpu(task4kernelset2dpu=None):

    '''
    sets kernels for DPU
    '''
    global dpu2kernel4xi  
    global folder2lib4dpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernel4dpu"
    method2print = "set2kernel4dpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernel4dpu-started: " + str(set2kernel4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernel4dpu at 0x0000000003837948> 
    
    keys2task = task4kernelset2dpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernel4dpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
        
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if dpu2kernel4xi is None:
            dpu2kernel4xi = create2kernel4dpu()                                                                              # INITIALIZE PROGRAM FOR DPU 
            message2print = "{(Step 1C/70) set" + "; dpu2kernel4xi-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4dpu-skipped-by-set2kernel4dpu: " + str(create2kernel4dpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            dpu2kernel4xi = create2kernel4dpu()
            message2print = "{(Step 1E/70) set" + "; dpu2kernel4xi-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            dpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; dpu2kernel4xi-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['DATA2CALLBACK'] = task4kernelset2dpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-dpu2kernel4xi-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelset2dpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-dpu2kernel4xi-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['PLATFORM'] = task4kernelset2dpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-dpu2kernel4xi-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2dpu-try-by-set2kernel4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['CONTEXT'] = task4kernelset2dpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-dpu2kernel4xi-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernel4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['DEVICE'] = task4kernelset2dpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-dpu2kernel4xi-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['CODE2ERROR'] = task4kernelset2dpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-dpu2kernel4xi-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['QUEUE'] = task4kernelset2dpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-dpu2kernel4xi-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['PIPE'] = task4kernelset2dpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-dpu2kernel4xi-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernel4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['COMMANDQUEUE']  = task4kernelset2dpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernel4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        dpu2kernel4xi['BUFFER']  = task4kernelset2dpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernel4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['EVENT']  = task4kernelset2dpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'
                    
              
    message2print = "{(Step 31A/70) try" + "; count2py4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4PY                           
        # ---------------------------------------------------------------------------------------------             
        dpu2kernel4xi['COUNT4PY']  = task4kernelset2dpu['COUNT4PY']  
 
        message2print = "{(Step 31B/70) set" + "; count2py4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count2py4dpu-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  
                
    message2print = "{(Step 31C/70) try" + "; count2pyc4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31C)  - COUNT4PYC                           
        # ---------------------------------------------------------------------------------------------             
        dpu2kernel4xi['COUNT4PYC']  = task4kernelset2dpu['COUNT4PYC']  
 
        message2print = "{(Step 31D/70) set" + "; count2pyc4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31D-'
    except: 
        message2print = "{(Step 31Z2/70) yielded" + "; count2pyc4dpu-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z2-'  
                
    message2print = "{(Step 31E/70) try" + "; count2c4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31E)  - COUNT4C                           
        # ---------------------------------------------------------------------------------------------             
        dpu2kernel4xi['COUNT4C']  = task4kernelset2dpu['COUNT4C']  
 
        message2print = "{(Step 31F/70) set" + "; count2c4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31F-'
    except: 
        message2print = "{(Step 31Z3/70) yielded" + "; count2c4dpu-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z3-'                  
                
    message2print = "{(Step 31G/70) try" + "; count2bin4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31G)  - COUNT4BIN                           
        # ---------------------------------------------------------------------------------------------             
        dpu2kernel4xi['COUNT4BIN']  = task4kernelset2dpu['COUNT4BIN']  
 
        message2print = "{(Step 31H/70) set" + "; count2bin4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31H-'
    except: 
        message2print = "{(Step 31Z4/70) yielded" + "; count2bin4dpu-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z4-'  
        
    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernel4dpu: " + str(task4kernelset2dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32B) DIRECTORY4PY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dpu2kernel4xi['DIRECTORY4PY']  = task4kernelset2dpu['DIRECTORY4PY'] 
        
        message2print = "{(Step 32B/70) set" + "; directory2py4dpu-set-by-set2kernelwithdirectory2py4dpu4dpu to: " + str(dpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory2py4dpu-yielded-by-set2kernelwithdirectory2py4dpu4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32C) DIRECTORY4PYC - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dpu2kernel4xi['DIRECTORY4PYC']  = task4kernelset2dpu['DIRECTORY4PYC'] 
        
        message2print = "{(Step 32C/70) set" + "; directory2pyc4dpu-set-by-set2kernelwithdirectory2pyc4dpu4dpu to: " + str(dpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32C-'
    except: 
        message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4dpu-yielded-by-set2kernelwithdirectory2pyc4dpu4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z2-'

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32D) DIRECTORY4C - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dpu2kernel4xi['DIRECTORY4CPP']  = task4kernelset2dpu['DIRECTORY4CPP'] 
        
        message2print = "{(Step 32D/70) set" + "; directory2c4dpu-set-by-set2kernelwithdirectory2c4dpu4dpu to: " + str(dpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32D-'
    except: 
        message2print = "{(Step 32Z3/70) yielded" + "; directory2c4dpu-yielded-by-set2kernelwithdirectory2c4dpu4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z3-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32E) DIRECTORY4BIN - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dpu2kernel4xi['DIRECTORY4BIN']  = task4kernelset2dpu['DIRECTORY4BIN'] 
        
        message2print = "{(Step 32E/70) set" + "; directory2bin4dpu-set-by-set2kernelwithdirectory2bin4dpu4dpu to: " + str(dpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32E-'
    except: 
        message2print = "{(Step 32Z4/70) yielded" + "; directory2bin4dpu-yielded-by-set2kernelwithdirectory2bin4dpu4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z34-'         
                         
    message2print = "{(Step 33A/70) try" + "; code2py4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33B) CODE4PY - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['CODE4PY']  = task4kernelset2dpu['CODE4PY']  
 
        message2print = "{(Step 33B/70) set" + "; code2py4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dpu + 'dpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernel = "dpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code2py4dpu-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2py4dpu2nack  = code2py4dpu2nack + '33Z1-'        
                         
    message2print = "{(Step 33C/70) try" + "; code2c4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33C) CODE4C - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['CODE4CPP']  = task4kernelset2dpu['CODE4CPP']  
 
        message2print = "{(Step 33D/70) set" + "; code2c4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['CODE4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dpu + 
 
        code2c4dpu2ack  = code2c4dpu2ack + '33D-'
    except: 
        message2print = "{(Step 33Z2/70) yielded" + "; code2c4dpu-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2c4dpu2nack  = code2c4dpu2nack + '33Z2-'                     
                         
    message2print = "{(Step 33D/70) try" + "; code2pyc4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4PYC - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['CODE4PYC']  = task4kernelset2dpu['CODE4PYC']  
 
        message2print = "{(Step 33E/70) set" + "; code2pyc4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dpu + 
 
        code2pyc4dpu2ack  = code2pyc4dpu2ack + '33E-'
    except: 
        message2print = "{(Step 33Z3/70) yielded" + "; code2pyc4dpu-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2pyc4dpu2nack  = code2pyc4dpu2nack + '33Z3-'        
                         
    message2print = "{(Step 33F/70) try" + "; code2bin4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4BIN - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['CODE4BIN']  = task4kernelset2dpu['CODE4BIN']  
 
        message2print = "{(Step 33G/70) set" + "; code2bin4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dpu + 
 
        code2bin4dpu2ack  = code2bin4dpu2ack + '33G-'
    except: 
        message2print = "{(Step 33Z4/70) yielded" + "; code2bin4dpu-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2bin4dpu2nack  = code2bin4dpu2nack + '33Z4-'                
                
    message2print = "{(Step 34A/70) try" + "; size2py4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34B) SIZE4PY - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['SIZE4PY']  = task4kernelset2dpu['SIZE4PY']  
 
        message2print = "{(Step 34B/70) set" + "; size2py4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size2py4dpu-yielded-by-set2kernel4dpu: " + str(task4kernelset2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 34C/70) try" + "; size2c4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34C) SIZE4C - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['SIZE4C']  = task4kernelset2dpu['SIZE4C']  
 
        message2print = "{(Step 34D/70) set" + "; size2c4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34D-'
    except: 
        message2print = "{(Step 34Z2/70) yielded" + "; size2c4dpu-yielded-by-set2kernel4dpu: " + str(task4kernelset2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z2-'
                
    message2print = "{(Step 34E/70) try" + "; size2pyc4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34E) SIZE4PYC - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['SIZE4PYC']  = task4kernelset2dpu['SIZE4PYC']  
 
        message2print = "{(Step 34F/70) set" + "; size2pyc4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34F-'
    except: 
        message2print = "{(Step 34Z3/70) yielded" + "; size2pyc4dpu-yielded-by-set2kernel4dpu: " + str(task4kernelset2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z3-'          
                
    message2print = "{(Step 34G/70) try" + "; size2bin4dpu-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34G) SIZE4BIN - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['SIZE4BIN']  = task4kernelset2dpu['SIZE4BIN']  
 
        message2print = "{(Step 34H/70) set" + "; size2bin4dpu-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34H-'
    except: 
        message2print = "{(Step 34Z4/70) yielded" + "; size2bin4dpu-yielded-by-set2kernel4dpu: " + str(task4kernelset2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z4-'  
        
    
                                  
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE (DICTIONARY) - REQUIRED                     
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['LANGUAGE']  = task4kernelset2dpu['LANGUAGE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernel4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['COUNT2REFERENCE']  = task4kernelset2dpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernel4dpu to: " + str(dpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2kernel4xi ['ACK2RETURN']  = code2ack
    dpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernel4dpu = dpu2kernel4xi.keys()
    for key2kernel4dpu in keys2kernel4dpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dpu-returning-by-set2kernel4dpu: " + str(key2kernel4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return dpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelarg4dpu" usage = "
#
#   ... prepare task4set2kernelargws ...    
#
#   response4set2kernelarg = {} 
#   print('(Step 17F/700) OF DPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS : ', set2kernelarg4dpu)   
#   # <function set2kernelarg4dpu at 0x0000000003837948>
#   try:                               
#       response4set2kernel = set2kernelarg4dpu(task4set2kernelargws)
#       print('(Step 17G/700) OF DPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS: ', set2kernelarg4dpu)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF DPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS: ', set2kernelarg4dpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernelarg4dpu(task4kernelargset2dpu=None):

    '''
    sets kernel arguments for DPU
    '''
    global dpu2kernel4xi  
    global folder2lib4dpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernelarg4dpu"
    method2print = "set2kernelarg4dpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernelarg4dpu-started: " + str(set2kernelarg4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernelarg4dpu at 0x0000000003837948> 
    
    keys2task = task4kernelargset2dpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernelarg4dpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if dpu2kernel4xi is None:
            dpu2kernel4xi = create2kernel4dpu()                                                                              # INITIALIZE PROGRAM FOR DPU 
            message2print = "{(Step 1C/70) set" + "; dpu2kernel4xi-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4dpu-skipped-by-set2kernelarg4dpu: " + str(create2kernel4dpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            dpu2kernel4xi = create2kernel4dpu()
            message2print = "{(Step 1E/70) set" + "; dpu2kernel4xi-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            dpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; dpu2kernel4xi-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['DATA2CALLBACK'] = task4kernelargset2dpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-dpu2kernel4xi-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelargset2dpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-dpu2kernel4xi-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['PLATFORM'] = task4kernelargset2dpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-dpu2kernel4xi-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2dpu-try-by-set2kernelarg4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['CONTEXT'] = task4kernelargset2dpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-dpu2kernel4xi-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernelarg4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['DEVICE'] = task4kernelargset2dpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-dpu2kernel4xi-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['CODE2ERROR'] = task4kernelargset2dpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-dpu2kernel4xi-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['QUEUE'] = task4kernelargset2dpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-dpu2kernel4xi-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['PIPE'] = task4kernelargset2dpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-dpu2kernel4xi-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernelarg4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['COMMANDQUEUE']  = task4kernelargset2dpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernelarg4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        dpu2kernel4xi['BUFFER']  = task4kernelargset2dpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernelarg4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['EVENT']  = task4kernelargset2dpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'            
                
    message2print = "{(Step 31A/70) try" + "; count4source-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4SOURCE                           
        # ---------------------------------------------------------------------------------------------             
        dpu2kernel4xi['COUNT4SOURCE']  = task4kernelargset2dpu['COUNT4SOURCE']  
 
        message2print = "{(Step 31B/70) set" + "; count4source-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count4source-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  

    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernelarg4dpu: " + str(task4kernelargset2dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'CODE2ERROR': 0 ... 'DIRECTORY4SOURCE': '...//a' ... 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) DIRECTORY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        dpu2kernel4xi['DIRECTORY4SOURCE']  = task4kernelargset2dpu['DIRECTORY4SOURCE'] 
        
        message2print = "{(Step 32B/70) set" + "; directory-set-by-set2kernelargwithdirectory4dpu to: " + str(dpu2kernel4xi['DIRECTORY4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # OK
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory-yielded-by-set2kernelargwithdirectory4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 
        
    message2print = "{(Step 33A/70) try" + "; code-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['CODE4SOURCE']  = task4kernelargset2dpu['CODE4SOURCE']  
 
        message2print = "{(Step 33B/70) set" + "; code-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['CODE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4dpu + 'dpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernelarg = "dpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '33Z1-'             
        
    message2print = "{(Step 34A/70) try" + "; size-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) SIZE - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['SIZE4SOURCE']  = task4kernelargset2dpu['SIZE4SOURCE']  
 
        message2print = "{(Step 34B/70) set" + "; size-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['SIZE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size-yielded-by-set2kernelarg4dpu: " + str(task4kernelargset2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['LANGUAGE4SOURCE']  = task4kernelargset2dpu['LANGUAGE4SOURCE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['LANGUAGE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernelarg4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2kernel4xi['COUNT2REFERENCE']  = task4kernelargset2dpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernelarg4dpu to: " + str(dpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernelarg4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2kernel4xi ['ACK2RETURN']  = code2ack
    dpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernelarg4dpu = dpu2kernel4xi.keys()
    for key2kernelarg4dpu in keys2kernelarg4dpu:
        message2print = "{(Step 70/70) returning" + "; key2kernelarg4dpu-returning-by-set2kernelarg4dpu: " + str(key2kernelarg4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return dpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2kernel4dpu" usage = "
#
#   task4release2kernel  = {} 
#   task4release2kernel  ['COUNT2REFERENCE'] = 1 
#   response4release2kernel = {}
#   
#   print('(Step 18A/700) OF DPU2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF DPU DEVICE ', time4xi())    
#   try:                               
#       response4release2kernel = release2kernel4dpu(task4release2kernel)
#       print('(Step 18B/700) OF DPU2KERNEL4XI5TEST - RELEASED KERNEL OF DPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 18Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF DPU DEVICE ', time4xi())                                                                                                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def release2kernel4dpu(task4release2dpu=None):

    '''
    releases kernel for DPU
    '''
    global dpu2kernel4xi  
    global folder2lib4dpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2kernel4dpu"
    method2print = "release2kernel4dpu" 

    message2print = "{(Step 1A/33) started" + "; release2kernel4dpu-started: " + str(release2kernel4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2dpu-to-release2kernel4dpu: " + str(task4release2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    

    code2ack  = ' '
    code2nack = ' '

    try:
        if dpu2kernel4xi is None:
            dpu2kernel4xi = create2kernel4dpu()                                                                       # INITIALIZE KERNEL                 
    except:
        try:
            dpu2kernel4xi = create2kernel4dpu()
        except:
            dpu2kernel4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; dpu2kernel4xi-yielded-by-release2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2kernel4dpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2dpu is None:
        task4release2dpu = {}
        task4release2dpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        dpu2kernel4xi['COUNT2REFERENCE'] = dpu2kernel4xi['COUNT2REFERENCE'] - task4release2dpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2kernel4dpu: " + str(dpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        if dpu2kernel4xi['COUNT2REFERENCE'] < 0:
            dpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2kernel4dpu: " + " ** " + str(dpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            dpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2kernel4dpu: " + " ** " + str(dpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; dpu2kernel4xi-yielded-by-release2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2kernel4xi ['ACK2RETURN']  = code2ack
    dpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2program4dpu = dpu2kernel4xi.keys()
    for key2program4dpu in keys2program4dpu:
        message2print = "{(Step 70/70) returning" + "; key2program4dpu-returning-by-release2kernel4dpu: " + str(key2program4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return dpu2kernel4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2kernel4dpu" usage = "
#
#   task4retain2kernel  = {} 
#   task4retain2kernel  ['COUNT2REFERENCE'] = 1 
#   response4retain2kernel = {}
#   
#   print('(Step 19A/700) OF DPU2KERNEL4XI5TEST - TRYING TO RETAIN PROGRAM OF DPU DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4retain2kernel = retain2kernel4dpu(task4retain2kernel)
#       print('(Step 19B/700) OF DPU2KERNEL4XI5TEST - RETAINED PROGRAM OF DPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 19Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO RETAIN PROGRAM OF DPU DEVICE ', time4xi())                                                                                                  
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2kernel4dpu(task4retain2dpu=None):

    '''
    retains kernel of DPU
    '''
    global dpu2kernel4xi 
    global folder2lib4dpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2kernel4dpu"
    method2print = "retain2kernel4dpu"

    message2print = "{(Step 1A/33) started" + "; retain2kernel4dpu-started: " + str(retain2kernel4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2dpu-to-retain2kernel4dpu: " + str(task4retain2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2dpu is None:
        task4retain2dpu = {}
        task4retain2dpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2dpu-set-by-retain2kernel4dpu to: " + str(task4retain2dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2dpu.keys():
        pass
    else:
        task4retain2dpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2kernel4dpu to: " + str(task4retain2dpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                   
    if task4retain2dpu['COUNT2REFERENCE'] < 1:
        task4retain2dpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2kernel4dpu to: " + str(task4retain2dpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE PROGRAM IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if dpu2kernel4xi is None:
            dpu2kernel4xi = create2kernel4dpu()
            message2print = "{(Step 4A/70) created" + "; dpu2kernel4xi-created-by-retain2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            dpu2kernel4xi = create2kernel4dpu()
            message2print = "{(Step 4B/70) created" + "; dpu2kernel4xi-created-by-retain2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            dpu2kernel4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; dpu2kernel4xi-yielded-by-retain2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        dpu2kernel4xi['COUNT2REFERENCE'] = dpu2kernel4xi['COUNT2REFERENCE'] + task4retain2dpu['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2kernel4dpu: " + str(dpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1            
        if dpu2kernel4xi['COUNT2REFERENCE'] <= 0:
            dpu2kernel4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2kernel4dpu: " + " ** " + str(dpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            dpu2kernel4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2kernel4dpu: " + " ** " + str(dpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; dpu2kernel4xi-yielded-by-retain2kernel4dpu: " + str(dpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    dpu2kernel4xi ['ACK2RETURN']  = code2ack
    dpu2kernel4xi ['NACK2RETURN'] = code2nack     
     
    keys2program4dpu = dpu2kernel4xi.keys()
    for key2program4dpu in keys2program4dpu:
        message2print = "{(Step 70/70) returning" + "; key2program4dpu-returning-by-retain2kernel4dpu: " + str(key2program4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return dpu2kernel4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelinfo4dpu" usage = "
#
#   print('(Step 3B1/700) OF DPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFORMATION FOR DPU ', time4xi())     
#   try:
#       response4kernelinfo2dpu = get2kernelinfo4dpu() 
#       print('(Step 3B2/700) OF DPU2KERNEL4XI5TEST - GOT KERNEL INFORMATION FOR DPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF DPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFORMATION FOR DPU', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelinfo4dpu(task4getinfo2kernel=None):

    '''
    gets kernel information of DPU
    '''
    
    global dpu2kernel4xi
    global folder2lib4dpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelinfo4dpu"
    method2print = "get2kernelinfo4dpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelinfo4dpu-started: " + str(get2kernelinfo4dpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelinfo4dpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    dpu2kernel = {}
    try: 
        if dpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR DPU           
            # -------------------------------------------------------------------------------------           
            dpu2kernel = create2kernel4dpu()
            message2print = "{(Step 1B2/33) initialized" + "; dpu2kernel-initialized-by-get2kernelinfo4dpu to: " + str(dpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; dpu2kernel4xi-using-by-get2kernelinfo4dpu: " + str(dpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF DPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            dpu2kernel = dpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; dpu2kernel-got-by-get2kernelinfo4dpu: " + str(dpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF DPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4dpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                dpu2kernel [key2task] = dpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-dpu2kernel-set-by-get2kernelinfo4dpu to: " + str(dpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4dpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4dpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; dpu2kernel4xi-using-by-get2kernel4dpu: " + str(dpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            dpu2kernel = create2kernel4dpu()
            
            message2print = "{(Step 1F/33) initialized" + "; dpu2kernel-initialized-by-get2kernelinfo4dpu to: " + str(dpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                dpu2kernel = dpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; dpu2kernel-set-by-get2kernelinfo4dpu to: " + str(dpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4dpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        dpu2kernel [key2task] = dpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-dpu2kernel -set-by-get2kernelinfo4dpu to: " + str(dpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4dpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            dpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; dpu2kernel-yielded-by-get2kernel4dpu: " + str(dpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4dpu = dpu2kernel4xi.keys()
    for key2kernel4dpu in keys2kernel4dpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dpu-returning-by-get2kernelinfo4dpu: " + str(key2kernel4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # CODE2ERROR ...
        
    return dpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelarginfo4dpu" usage = "
#
#   print('(Step 3B1/700) OF DPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENTGS INFO FOR DPU ', time4xi())     
#   try:
#       response4kernelinfo2dpu = get2kernelarginfo4dpu(task4getinfo2kernel) 
#       print('(Step 3B2/700) OF DPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENTGS INFO FOR DPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF DPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENTGS INFO FOR DPU ', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelarginfo4dpu(task4getinfo2kernel=None):

    '''
    gets kernel argument information of DPU
    '''
    
    global dpu2kernel4xi
    global folder2lib4dpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelarginfo4dpu"
    method2print = "get2kernelarginfo4dpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelarginfo4dpu-started: " + str(get2kernelarginfo4dpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelarginfo4dpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    dpu2kernel = {}
    try: 
        if dpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR DPU           
            # -------------------------------------------------------------------------------------           
            dpu2kernel = create2kernel4dpu()
            message2print = "{(Step 1B2/33) initialized" + "; dpu2kernel-initialized-by-get2kernelarginfo4dpu to: " + str(dpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; dpu2kernel4xi-using-by-get2kernelarginfo4dpu: " + str(dpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF DPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            dpu2kernel = dpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; dpu2kernel-got-by-get2kernelarginfo4dpu: " + str(dpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF DPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4dpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                dpu2kernel [key2task] = dpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-dpu2kernel-set-by-get2kernelarginfo4dpu to: " + str(dpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4dpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4dpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; dpu2kernel4xi-using-by-get2kernel4dpu: " + str(dpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            dpu2kernel = create2kernel4dpu()
            
            message2print = "{(Step 1F/33) initialized" + "; dpu2kernel-initialized-by-get2kernelarginfo4dpu to: " + str(dpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                dpu2kernel = dpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; dpu2kernel-set-by-get2kernelarginfo4dpu to: " + str(dpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4dpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        dpu2kernel [key2task] = dpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-dpu2kernel -set-by-get2kernelarginfo4dpu to: " + str(dpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4dpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            dpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; dpu2kernel-yielded-by-get2kernel4dpu: " + str(dpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4dpu = dpu2kernel4xi.keys()
    for key2kernel4dpu in keys2kernel4dpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4dpu-returning-by-get2kernelarginfo4dpu: " + str(key2kernel4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return dpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2buildinfo4dpu" usage = "
#
#   response4get2buildinfo = get2buildinfo4dpu()
#            
#">

# -------------------------------------------------------------------------------------------------   
def get2buildinfo4dpu(task4getinfo2build=None):

    '''
    gets dpu2build4xi and dpu2build4xi
    '''
    
    global dpu2build4xi
    global folder2lib4dpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2buildinfo4dpu"
    method2print = "get2buildinfo4dpu"

    message2print = "{(Step 0A/33) started" + "; get2buildinfo4dpu-started: " + str(get2buildinfo4dpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2build-passed-to-get2buildinfo4dpu: " + str(task4getinfo2build) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    dpu2build = {}
    try: 
        if dpu2build4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR DPU           
            # -------------------------------------------------------------------------------------           
            dpu2build = {}
            message2print = "{(Step 1B2/33) initialized" + "; dpu2build-initialized-by-get2buildinfo4dpu to: " + str(dpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; dpu2build4xi-using-by-get2buildinfo4dpu: " + str(dpu2build4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF DPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2build is None:
            task4getinfo2build = {}
            dpu2build = dpu2build4xi
            message2print = "{(Step 1C/33) using" + "; dpu2build-got-by-get2buildinfo4dpu: " + str(dpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4buildinfo = task4getinfo2build.keys()
        keys2task = task4getinfo2build.keys()
            
        # -------------------------------------------------------------------------------------
        # BUILD INFO OF DPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2build4dpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                dpu2build [key2task] = dpu2build4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-dpu2build-set-by-get2buildinfo4dpu to: " + str(dpu2build [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2build4dpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2build-using-by-get2build4dpu: " + str(task4getinfo2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; dpu2build4xi-using-by-get2build4dpu: " + str(dpu2build4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE BUILD           
            # -------------------------------------------------------------------------------------           
            dpu2build = {}
            message2print = "{(Step 1F/33) initialized" + "; dpu2build-initialized-by-get2buildinfo4dpu to: " + str(dpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2build is None:
                dpu2build = dpu2build4xi
                message2print = "{(Step 1G/33) set" + "; dpu2build-set-by-get2buildinfo4dpu to: " + str(dpu2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2build.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2build4dpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        dpu2build [key2task] = dpu2build4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-dpu2build -set-by-get2buildinfo4dpu to: " + str(dpu2build  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2build4dpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            dpu2build = {}
            message2print = "{(Step 1Z3/70) yielded" + "; dpu2build-yielded-by-get2build4dpu: " + str(dpu2build) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; dpu2build-returning-by-get2buildinfo4dpu: " + str(dpu2build) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
    
    return dpu2build
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelworkgroupinfo4dpu" usage = "
#     
#   print('(Step 2AB2/700) OF DPU2KERNEL4XI5TEST - TRYING TO GET KERNEL WORK GROUP INFORMATION ', time4xi())           
#   try:
#       response4link = get2kernelworkgroupinfo4dpu()
#       print('(Step 2BB2/700) OF DPU2KERNEL4XI5TEST - GOT KERNEL WORK GROUP INFORMATION ', time4xi()) 
#   except:
#       print('(Step 2Z2/700) OF DPU2KERNEL4XI5TEST *** FAILED TO KERNEL WORK GROUP INFORMATION ', time4xi())                                                                     
#          
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelworkgroupinfo4dpu(task4kernelworkgroupinfo2dpu=None):

    '''
    gets kernel workgroup info of DPU
    '''
    global dpu2kernel4xi                                                                                            # Kernel of DPU    
    global import2use4dpu                                                                                           # Imports of DPU
    global target2function4dpu                                                                                      # Target function of Process4Xi
    global folder2lib4dpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelworkgroupinfo4dpu" 
    method2print = "get2kernelworkgroupinfo4dpu"

    message2print = "{(Step 1A/70) started" + "; get2kernelworkgroupinfo4dpu-started: " + str(get2kernelworkgroupinfo4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernelworkgroupinfo2dpu-to-get2kernelworkgroupinfo4dpu: " + str(task4kernelworkgroupinfo2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    process2kernelworkgroupinfo4dpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernelworkgroupinfo2dpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernelworkgroupinfo2dpu-yielded-by-get2kernelworkgroupinfo4dpu: " + str(task4kernelworkgroupinfo2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - LINK SOURCES INSIDE PROGRAM OBJECT FOR DPU ! 
    # ---------------------------------------------------------------------------------------------    
    process2kernelworkgroupinfo4dpu = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; process2kernelworkgroupinfo4dpu-initialized-by-get2kernelworkgroupinfo4dpu to: " + str(process2kernelworkgroupinfo4dpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}

    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                  
        # ---------------------------------------------------------------------------------------------             
        keys2code4dpu = dpu2kernel4xi['CODE4SOURCE'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2code4dpu-using-by-get2kernelworkgroupinfo4dpu: " + str(keys2code4dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # dict_keys([folder2lib4dpu + 'dpu2sampler4xi5test.py'])
        
        unit4processing = "dpu"
        
        for key2code4dpu in keys2code4dpu:
            index2search=str.find(key2code4dpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2link = key2code4dpu[index2search:]                                                          # dpu2sampler4xi5test.py
                index2search=str.find(target2link,".py")
                if index2search == -1:
                    pass
                else:
                    target2link4dpu = target2link[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2link4dpu-set-by-get2kernelworkgroupinfo4dpu to: " + str(target2link4dpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # dpu2sampler4xi5test

                    p2code4dpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4DPU 
                        # ---------------------------------------------------------------------------------------------    
      
                        try:
                            import2use4dpu.get(target2link4dpu, handle2error4dpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2link4dpu-imported-by-get2kernelworkgroupinfo4dpu: " + str(target2link4dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # dpu2sampler4xi5test
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4dpu-failed-by-get2kernelworkgroupinfo4dpu: " + str(import2use4dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2link4dpu-used-by-get2kernelworkgroupinfo4dpu: " + str(target2link4dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4DPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2dpu = Process4Xi(target=target2function4dpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2dpu-created-by-get2kernelworkgroupinfo4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-2, initial)>
                        
                        process2kernelworkgroupinfo4dpu[key2code4dpu] = p2dpu
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2dpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2dpu-started-by-get2kernelworkgroupinfo4dpu: " + str(p2dpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-2
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4dpu = p2dpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-get2kernelworkgroupinfo4dpu: " + str(status2process4dpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2dpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2dpu-run-by-get2kernelworkgroupinfo4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-get2kernelworkgroupinfo4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-get2kernelworkgroupinfo4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-get2kernelworkgroupinfo4dpu: " + str(p2dpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2code4dpu-failed-by-get2kernelworkgroupinfo4dpu: " + str(p2code4dpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    

 
        message2print = "{(Step 38A/70) set" + "; process2kernelworkgroupinfo4dpu-set-by-get2kernelworkgroupinfo4dpu to: " + str(process2kernelworkgroupinfo4dpu)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; code-yielded-by-get2kernelworkgroupinfo4dpu: " + str(dpu2kernel4xi['CODE4SOURCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2kernel4xi ['ACK2RETURN']  = code2ack
    dpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; process2kernelworkgroupinfo4dpu-returning-by-get2kernelworkgroupinfo4dpu: " + str(process2kernelworkgroupinfo4dpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 
    return process2kernelworkgroupinfo4dpu
            
#</function4xi> 
 
                                        
# =================================================================================================
#<class4xi class = "DPU2Kernel4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for DPU kernels" usage = "Kernel4Xi of DPU"
#>

# =================================================================================================
class DPU2Kernel4Xi(object): 
    ''' 
    DPU2Kernel4Xi offers  methods for DPU kernels
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2dpu = cpu_corecount4xi()
    #"
    #/>
       
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2kernel',                      # ACK              

            'execute2kernel',                  # ACK 5.8    p169                                             
            'execute2task',                    # ACK 5.8    p172   
            'execute2nativekernel',            # ACK 5.8    p174     
            
            'create2kernel',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram',         # ACK 5.7.1  p158  
                       
            'delete2kernel',                   # ACK

            'fetch2kernel',                    # ACK 
            
            'get2kernelinfo',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo',         # ACK 5.7.3  p164  
            'get2kernelarginfo',               # ACK 5.7.3  p166                                  
            
            'release2kernel',                  # ACK 5.7.1  p159                                         
            'retain2kernel',                   # ACK 5.7.1  p159   
 
            'set2kernel',                      # ACK 
            'set2kernelcallback',              # ACK 
            'set2kernelarg',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel',                    # ACK 
            
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-DPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 110A/700) OF DPU2KERNEL4XI5TEST - CREATING KERNEL OBJECT OF DPU ', time4xi())        
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                  
    #       # ---------------------------------------------------------------------------------------------        
    #       kernelobject2dpu = DPU2Kernel4Xi()
    #       print('(Step 110B/700) OF DPU2KERNEL4XI5TEST - CREATED KERNEL OBJECT OF DPU: ', kernelobject2dpu)                                  
    #       # 
    #   except:
    #       print('(Step 110Z/700) OF DPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT OF DPU') 
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4kernel2dpu = None):
        '''
        _init__ method initializes DPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "DPU2Kernel4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-DPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; dpu2kernel2xi-of-DPU2Kernel4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-dpu2kernel2xi-of-DPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2dpu-sharing-by-dpu2kernel2xi-of-DPU2Kernel4Xi: " + str(DPU2Kernel4Xi.classvariable2dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4        
                                
        message2print = "{(Step 1E/33) passed" + "; task4kernel2dpu-passed-to-init-of-DPU2Kernel4Xi: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                      
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
    
        message2print = "{(Step 2A/33) passing" + "; task4kernel2dpu-passing-to-create2kernel4dpu-by-init-of-DPU2Kernel4Xi: " + str(task4kernel2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
                
        dpu2kernel2xi = create2kernel4dpu(task4kernel2dpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2kernel4dpu-performed-by-init-of-DPU2Kernel4Xi: " + str(create2kernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2kernel4dpu at 0x00000000041E54C8>
       
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; dpu2kernel2xi-of-DPU2Kernel4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-dpu2kernel2xi-of-DPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2dpu-shared-by-dpu2kernel2xi-of-DPU2Kernel4Xi: " + str(DPU2Kernel4Xi.classvariable2dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #     
       
        message2print = "{(Step 3D/33) returning" + "; init-of-DPU2Kernel4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2kernel-of-DPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 132A/700) OF DPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL TO DPU  WITH METHOD', time4xi())         
    #   try:
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4dpu + 'dpu2dummy4xi.py'] = {}
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4dpu + 'dpu2dummy4xi.py'] [1] = '... profile = "11" />'
    #
    #       response4add2kernel = programobject2dpu.add2kernel(task4add2kernel) 
    #       print('(Step 132B/700) OF DPU2KERNEL4XI5TEST - ADDED KERNEL TO DPU  WITH METHOD', time4xi())
    #   except:
    #       print('(Step 132Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL TO DPU WITH METHOD *** ', time4xi())
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def add2kernel(self, task4add2kernel = None):
        '''
        adds kernel to DPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "add2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; add2kernel-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2kernel-passed-to-add2kernel-of-DPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2kernel-passing-to-add2kernel4dpu-by-add2kernel-of-DPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4add2kernel = add2kernel4dpu(task4add2kernel)

        message2print = "{(Step 2B/33) performed" + "; add2kernel4dpu-performed-by-add2kernel-of-DPU2Kernel4Xi: " + str(add2kernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4add2kernel-returning-by-add2kernel-of-DPU2Kernel4Xi: " + str(response4add2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4add2kernel
                                
                            
    #</methodize4xi>    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2task-of-DPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 240A/700) OF DPU2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF DPU WITH METHOD ', time4xi())    
    #   try:                               
    #       response4execute2task = programobject2dpu.execute2task() 
    #       print('(Step 240B/700) OF DPU2KERNEL4XI5TEST - EXECUTED TASK OF DPU WITH METHOD ', time4xi())
    #   except:
    #       print('(Step 240Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF DPU WITH METHOD ', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2task(self, task4execute = None):
        '''
        executes task of kernel of DPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "execute2task"
                     
        message2print = "{(Step 1A/33) started" + "; execute2task-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute-passed-to-create-of-DPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute-passing-to-execute2task4dpu-by-execute2task-of-DPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        dpu2program2xi = execute2task4dpu(task4execute)

        message2print = "{(Step 2B/33) performed" + "; execute2task4dpu-performed-by-execute2task-of-DPU2Kernel4Xi: " + str(execute2task4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; dpu2program2xi-returning-by-execute2task-of-DPU2Kernel4Xi: " + str(dpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return dpu2program2xi
                     
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2nativekernel-of-DPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121A1/700) OF DPU2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF DPU ', time4xi())      
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # COMPILE                        
    #       # ---------------------------------------------------------------------------------------------        
    #       response4compile = executeobject2dpu.execute2nativekernel()
    #       print('(Step 121A2/700) OF DPU2KERNEL4XI5TEST - EXECUTED KERNEL OF DPU', time4xi())                                   
    #   except:
    #       print('(Step 121AZ1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF DPU', time4xi())   
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2nativekernel(self, task4execute2kernel = None):
        '''
        executes native kernel of DPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "execute2nativekernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2nativekernel-of-DPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-create-of-DPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2nativekernel4dpu-by-execute2nativekernel-of-DPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        dpu2execute2xi = execute2nativekernel4dpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2nativekernel4dpu-performed-by-execute2nativekernel-of-DPU2Kernel4Xi: " + str(execute2nativekernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; dpu2execute2xi-returning-by-execute2nativekernel-of-DPU2Kernel4Xi: " + str(dpu2execute2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return dpu2execute2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelworkgroupinfo-of-DPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121C1/700) OF DPU2KERNEL4XI5TEST - TRYING TO GET WORK GROUP INFOR OF DPU WITH METHOD ', time4xi())      
    #   try:
    #      
    #       response4getworkgroupinfo = programobject2dpu.get2kernelworkgroupinfo()
    #       print('(Step 121C2/700) OF DPU2KERNEL4XI5TEST - GOT WORK GROUP INFOR OF DPU WITH METHOD ', time4xi())                                   
    #   except:
    #       print('(Step 121CZ1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO GET WORK GROUP INFOR OF DPU WITH METHOD ', time4xi())  
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelworkgroupinfo(self, task4getworkgroupinfo = None):
        '''
        get kernel work group info OF DPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "get2kernelworkgroupinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelworkgroupinfo-of-DPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4getworkgroupinfo-passed-to-create-of-DPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4getworkgroupinfo-passing-to-get2kernelworkgroupinfo4dpu-by-get2kernelworkgroupinfo-of-DPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        dpu2program2xi = get2kernelworkgroupinfo4dpu(task4getworkgroupinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelworkgroupinfo4dpu-performed-by-get2kernelworkgroupinfo-of-DPU2Kernel4Xi: " + str(get2kernelworkgroupinfo4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; dpu2program2xi-returning-by-get2kernelworkgroupinfo-of-DPU2Kernel4Xi: " + str(dpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return dpu2program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernel-of-DPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 190A/700) OF DPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR DPU ', time4xi()) 
    #   try:
    #       kernelobject2dpu = DPU2Kernel4Xi()                            
    #       response4create2kernel = kernelobject2dpu.create2kernel()
    #       print('(Step 190B/700) OF DPU2KERNEL4XI5TEST - CREATED KERNEL FOR DPU ', time4xi())
    #   except:
    #       print('(Step 190Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR DPU ', time4xi())                                    
    #           
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernel(self, task4kernel2create = None):
        '''
        create2kernel method creates kernel objects of DPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "create2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernel-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-DPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernel4dpu-by-create2kernel-of-DPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #  
  
        dpu2kernel2xi = create2kernel4dpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernel4dpu-performed-by-create2kernel-of-DPU2Kernel4Xi: " + str(create2kernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernel4dpu at 0x0000000003B0C5C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        keys2response4create = dpu2kernel2xi.keys() 
        message2print = "{(Step 33A/33) returning" + "; keys2response4create-returning-by-create2kernel-of-DPU2Kernel4Xi: " + str(keys2response4create) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # ['FUNCTION',
        #  'CODE2ERROR',
        #  'COUNT2REFERENCE',
        #  'DATA2CALLBACK',
        #  'BUFFER',
        #  'FUNCTION2CALLBACK',
        #  'ACK2RETURN',
        #  'QUEUE',
        #  'PLATFORM',
        #  'PROGRAM',
        #  'NACK2RETURN',
        #  'CONTEXT',
        #  'COMMANDQUEUE',
        #  'DEVICE',
        #  'EVENT',
        #  'PIPE']
        message2print = "{(Step 33B/33) returning" + "; function-returning-by-create2kernel-of-DPU2Kernel4Xi: " + str(dpu2kernel2xi['FUNCTION']) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # dpu2sampler4xi5test 
        
        return dpu2kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernelsinprogram-of-DPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 130A/700) OF DPU2KERNEL4XI5TEST - CREATING KERNELS IN PROGRM FOR DPU ', time4xi())      
    #   try:
    #       response4create2kernelsinprogram = kernelobject2dpu.create2kernelsinprogram()
    #       print('(Step 130A/700) OF DPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRM FOR DPU ', time4xi())
    #   except:
    #       print('(Step 130Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO KERNELS IN PROGRM FOR DPU', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernelsinprogram(self, task4kernel2create = None):
        '''
        creates kernels in program of DPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "create2kernelsinprogram"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernelsinprogram-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-DPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernelsinprogram4dpu-by-create2kernelsinprogram-of-DPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        dpu2kernel2xi = create2kernelsinprogram4dpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernelsinprogram4dpu-performed-by-create2kernelsinprogram-of-DPU2Kernel4Xi: " + str(create2kernelsinprogram4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernelsinprogram4dpu at 0x00000000040248C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; dpu2kernel2xi-returning-by-create2kernelsinprogram-of-DPU2Kernel4Xi: " + str(dpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return dpu2kernel2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2kernel-of-DPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 134A/700) OF DPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL IN PROGRAM OF DPU WITH METHOD ', time4xi())        
    #   try:
    #       task4delete2kernel = {}
    #       task4delete2kernel ['CODE4KERNEL'] = {}
    #       task4delete2kernel ['CODE4KERNEL'] [folder2lib4dpu + 'dummy3image4xi..py'] = 'Yes'
    #       task4delete2kernel ['SIZE4KERNEL'] = {}
    #       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4dpu + 'dummy3image4xi..py'] = 'Yes'
    #       
    #       response4delete2kernel = programobject2dpu.delete2kernel(task4delete2kernel)
    #       print('(Step 134B/700) OF DPU2KERNEL4XI5TEST - DELETED DELETE KERNEL IN PROGRAM of DPUWITH METHOD ', time4xi())                                                                  
    #   except:
    #       print('(Step 134Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO DELETE DELETE KERNEL IN PROGRAM OF DPU WITH METHOD *** ', time4xi())
    #                  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def delete2kernel(self, task4delete2kernel = None):
        '''
        deletes kernel in program of DPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "delete2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; delete2kernel-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2kernel-passed-to-delete2kernel-of-DPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2kernel-passing-to-delete2kernel4dpu-by-delete2kernel-of-DPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4delete2kernel = delete2kernel4dpu(task4delete2kernel)

        message2print = "{(Step 2B/33) performed" + "; delete2kernel4dpu-performed-by-delete2kernel-of-DPU2Kernel4Xi: " + str(delete2kernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4delete2kernel-returning-by-delete2kernel-of-DPU2Kernel4Xi: " + str(response4delete2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4delete2kernel
                                
                            
    #</methodize4xi>    


        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernel-of-DPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernel ...
    #   print('(Step 158A/700) OF DPU2KERNEL4XI5TEST - TRYING TO SET KERNEL OF DPU: ', time4xi()) 
    #   try: 
    #       response4set2kernel = kernelobject2dpu.set2kernel(task4set2kernel)
    #       print('(Step 158B/700) OF DPU2KERNEL4XI5TEST - SET KERNEL OF DPU: ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL OF DPU: ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernel(self, task4set2kernel = None):
        '''
        sets kernel DPU objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "set2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernel-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernel-passed-to-set2kernel-of-DPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernel-passing-to-set2kernel4dpu-by-set2kernel-of-DPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        dpu2kernel2xi = set2kernel4dpu(task4set2kernel)

        message2print = "{(Step 2B/33) performed" + "; set2kernel4dpu-performed-by-set2kernel-of-DPU2Kernel4Xi: " + str(set2kernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dpu2kernel2xi-returning-by-set2kernel-of-DPU2Kernel4Xi: " + str(dpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return dpu2kernel2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelarg-of-DPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernelarg ...
    #   print('(Step 158A/700) OF DPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS FOR DPU: ', time4xi())
    #   try: 
    #       response4set2kernelarg = programobject2dpu.set2kernelarg(task4set2kernelarg)
    #       print('(Step 158B/700) OF DPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS FOR DPU ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS FOR DPU ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelarg(self, task4set2kernelarg = None):
        '''
        sets kernel arguments for DPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "set2kernelarg"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelarg-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelarg-passed-to-set2kernelarg-of-DPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelarg-passing-to-set2kernelarg4dpu-by-set2kernelarg-of-DPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        dpu2program2xi = set2kernelarg4dpu(task4set2kernelarg)

        message2print = "{(Step 2B/33) performed" + "; set2kernelarg4dpu-performed-by-set2kernelarg-of-DPU2Kernel4Xi: " + str(set2kernelarg4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dpu2program2xi-returning-by-set2kernelarg-of-DPU2Kernel4Xi: " + str(dpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return dpu2program2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelinfo-of-DPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF DPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO ', time4xi())    
    #   try:                               
    #       response4get2kernelinfo = kernelobject2dpu.get2kernelinfo()                                 
    #       print('(Step 106B/700) OF DPU2KERNEL4XI5TEST - GOT GET KERNEL INFO ', time4xi())                             
    #   except:
    #       print('(Step 106Z/700) OF DPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO ', time4xi()) 
    #   
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelinfo(self, task4getinfo2kernel=None):
        '''
        gets kernel info of DPU 
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "get2kernelinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelinfo-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        dpu2kernel2xi = get2kernelinfo4dpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; dpu2kernel2xi-returning-by-get2kernelinfo-of-DPU2Kernel4Xi: " + str(dpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return dpu2kernel2xi
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelarginfo-of-DPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF DPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENT INFO OF DPU ', time4xi())    
    #   try:                               
    #       response4get2kernelarginfo = kernelobject2dpu.get2kernelarginfo()
    #       print('(Step 106B/700) OF DPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENT INFO OF DPU ', time4xi())                                   
    #   except:
    #       print('(Step 106Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENT INFO OF DPU ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelarginfo(self, task4getinfo2kernel=None):
        '''
        gets kernel argument info of DPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "get2kernelarginfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelarginfo-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:01:22 11/17/11 Pacific Standard Time

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        dpu2kernel2xi = get2kernelarginfo4dpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; dpu2kernel2xi-returning-by-get2kernelarginfo-of-DPU2Kernel4Xi: " + str(dpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return dpu2kernel2xi
                            
    #</methodize4xi>
   
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2buildinfo-of-DPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF DPU2BUILD4XI5TEST - TRYING TO GET BUILD INFO ', time4xi())    
    #   try:                               
    #                               
    #       response4get2buildinfo = programobject2dpu.get2buildinfo()
    #       print('(Step 106A2/700) OF DPU2BUILD4XI5TEST - GOT BUILD INFO ', time4xi())    
    #   except:
    #       print('(Step 106Z1/700) OF DPU2BUILD4XI5TEST *** FAILED TO GET BUILD INFO ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2buildinfo(self, task4getinfo2build=None):
        '''
        get2buildinfo method gets objects of DPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "get2buildinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2buildinfo-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        dpu2build2xi = get2buildinfo4dpu(task4getinfo2build)
        
        message2print = "{(Step 2A/33) returning" + "; dpu2build2xi-returning-by-get2buildinfo-of-DPU2Kernel4Xi: " + str(dpu2build2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        return dpu2build2xi
                            
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2kernel-of-DPU2Kernel4Xi" usage = "
    #
    #   print('(Step 170A/700) OF DPU2KERNEL4XI5TEST - RELEASING KERNEL ', time4xi())  
    #   task4release2kernel  = {}
    #   task4release2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4release2kernel = kernelobject2dpu.release2kernel(task4release2kernel)
    #       print('(Step 170B/700) OF DPU2KERNEL4XI5TEST - RELEASED KERNEL ', time4xi())
    #   except:
    #       print('(Step 170Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL ', time4xi())                        
    #       keys2response = response4release2kernel.keys()
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2kernel(self, task4release2kernel = None):
        '''
        releases DPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "release2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; release2kernel-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2kernel-passed-to-release2kernel-of-DPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2kernel-passing-to-release2kernel4dpu-by-release2kernel-of-DPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        dpu2kernel2xi = release2kernel4dpu(task4release2kernel)

        message2print = "{(Step 2B/33) performed" + "; release2kernel4dpu-performed-by-release2kernel-of-DPU2Kernel4Xi: " + str(release2kernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dpu2kernel2xi-returning-by-release2kernel-of-DPU2Kernel4Xi: " + str(dpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #               
                
        return dpu2kernel2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2kernel-of-DPU2Kernel4Xi" usage = "
    #
    #   print('(Step 180A/700) OF DPU2KERNEL4XI5TEST - RETAINING KERNEL ', time4xi())
    #   task4retain2kernel  = {}
    #   task4retain2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4retain2kernel = kernelobject2dpu.retain2kernel(task4retain2kernel)
    #       print('(Step 180B/700) OF DPU2KERNEL4XI5TEST - RETAINED KERNEL ', time4xi())
    #   except:
    #       print('(Step 180Z1/700) OF DPU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL ', time4xi())                    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2kernel(self, task4retain2kernel = None):
        '''
        retains DPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "retain2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; retain2kernel-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2kernel-of-DPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2kernel4dpu-by-retain-of-DPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
  
        dpu2kernel2xi = retain2kernel4dpu(task4retain2kernel)

        message2print = "{(Step 2B/33) performed" + "; retain2kernel4dpu-performed-by-retain2kernel-of-DPU2Kernel4Xi: " + str(retain2kernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dpu2kernel2xi-returning-by-retain2kernel-of-DPU2Kernel4Xi: " + str(dpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
            
                
        return dpu2kernel2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2kernel-of-DPU2Kernel4Xi" usage = "
    #     
    #   print('(Step 210A/25) OF DPU2KERNEL4XI5TEST - TRYING TO TRACE DPU: ', time4xi())      
    #   trace2dpu = None
    #   try:
    #       trace2dpu = programobject2dpu.trace2kernel() 
    #               print('(Step 210B/25) OF DPU2KERNEL4XI5TEST - TRACE2DPU: ', trace2dpu)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4dpu-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4dpu', 'METHOD': 'trace2kernel4dpu'}
    #        except:
    #           print('(Step 210Z1/25) OF DPU2KERNEL4XI5TEST *** FAILED TO TRACE DPU: ', trace2dpu) 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2kernel(self, task4trace2kernel = None):
        '''
        traces DPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "trace2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; trace2kernel-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2kernel-passed-to-trace-of-DPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2kernel-passing-to-trace2kernel4dpu-by-trace2kernel-of-DPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = trace2kernel4dpu(task4trace2kernel)

        message2print = "{(Step 2B/33) performed" + "; trace2kernel4dpu-performed-by-trace2kernel-of-DPU2Kernel4Xi: " + str(trace2kernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2kernel-of-DPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2kernel-of-DPU2Kernel4Xi" usage = "
    #        
    #   print('(Step 220A/25) OF DPU2KERNEL4XI5TEST - TRYING TO UNLOAD COMPILER OF DPU: ', time4xi())      
    #   try:
    #       response4execute2kernel = programobject2dpu.execute2kernel() 
    #       print('(Step 220B/25) OF DPU2KERNEL4XI5TEST - UNLOADED COMPILER OF DPU: ', response4execute2kernel)  
    #       # 
    #   except:
    #       print('(Step 220Z1/25) OF DPU2KERNEL4XI5TEST *** FAILED TO TO UNLOAD COMPILER OF DPU: ', time4xi()) 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def execute2kernel(self, task4execute2kernel = None):
        '''
        executes kernel
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "execute2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2kernel-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-trace-of-DPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2kernel4dpu-by-execute2kernel-of-DPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = execute2kernel4dpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2kernel4dpu-performed-by-execute2kernel-of-DPU2Kernel4Xi: " + str(execute2kernel4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-execute2kernel-of-DPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelcallback-of-DPU2Kernel4Xi" usage = "
    #
    #   print('(Step 200A/700) OF DPU2KERNEL4XI5TEST - TRYING TO SET KERNELCALLBACK WITH METHOD OF OBJECT XI2DPU: ', programobject2dpu) 
    #   try:
    #       callback2dpu = programobject2dpu.set2kernelcallback()                                  
    #       print('(Step 200B/700) OF DPU2KERNEL4XI5TEST - SET KERNELWITH CALLBACK TO: ', callback2dpu)
    #       # 
    #   except:
    #       print('(Step 200Z/700) OF DPU2KERNEL4XI5TEST *** FAILED TO SET KERNELCALLBACK WITH METHOD ***', time4xi())
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelcallback(self, task4set2kernelcallback = None): 
        '''
        set2kernelcallback of DPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Kernel4Xi"
        method2print = "set2kernelcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelcallback-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelcallback-passed-to-set2kernelcallback-of-DPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelcallback-passing-to-set2kernelcallback-by-set2kernelcallback-of-DPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        
        callback2dpu4program = {} 
        try:
            callback2dpu4program = set2kernelcallback4dpu (task4set2kernelcallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2dpu4program-failed-by-set2kernelcallback-of-DPU2Kernel4Xi: " + str(callback2dpu4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2dpu4program-returning-by-set2kernelcallback-of-DPU2Kernel4Xi: " + str(callback2dpu4program) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2kernel4dpu at 0x00000000038CF5C8> 
        
                                             
        return callback2dpu4program
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-DPU2Kernel4Xi" usage = "
    #
    #   print('(Step 310A/700) OF DPU2KERNEL4XI5TEST - SENSING ', time4xi())  
    #   try:
    #       print(programobject2dpu.sense())
    #       print('(Step 310B/700) OF DPU2KERNEL4XI5TEST - SENSED ', time4xi()) 
    #       # 
    #   except:
    #       print('(Step 310Z/700) OF DPU2KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses DPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'DPU2Kernel4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; DPU2Kernel4Xi-sensing-by-sense-of-DPU2Kernel4Xi: " + str(DPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-DPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2dpu-of-DPU2Kernel4Xi'] = DPU2Kernel4Xi.classvariable2dpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-DPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; DPU2Kernel4Xi-sensed-by-sense-of-DPU2Kernel4Xi: " + str(DPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-DPU2Kernel4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-DPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 320A/700) OF DPU2KERNEL4XI5TEST - REASONING ', time4xi())
    #   try:
    #       print(programobject2dpu.reason())
    #       print('(Step 320B/700) OF DPU2KERNEL4XI5TEST - REASONED ', time4xi())
    #       # 
    #   except:
    #       print('(Step 320Z/700) OF DPU2KERNEL4XI5TEST *** FAILED TO REASON ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons DPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'DPU2Kernel4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; DPU2Kernel4Xi-reasoning-by-reason-of-DPU2Kernel4Xi: " + str(DPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-DPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-DPU2Kernel4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-DPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; DPU2Kernel4Xi-reasoned-by-reason-of-DPU2Kernel4Xi: " + str(DPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-DPU2Kernel4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-DPU2Kernel4Xi" usage = "
    #
    #   print('(Step 330A/700) OF DPU2KERNEL4XI5TEST - ACING ', time4xi())   
    #   try:
    #       print(programobject2dpu.ace())
    #       print('(Step 330B/700) OF DPU2KERNEL4XI5TEST - ACED ', time4xi())                                                 
    #       # 
    #   except:
    #       print('(Step 330Z/700) OF DPU2KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())                                 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces DPU2Kernel4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'DPU2Kernel4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-DPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; DPU2Kernel4Xi-acing-by-ace-of-DPU2Kernel4Xi: " + str(DPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #      
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-DPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-DPU2Kernel4Xi'] = DPU2Kernel4Xi.classvariable2dpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-DPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; DPU2Kernel4Xi-aced-by-ace-of-DPU2Kernel4Xi: " + str(DPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'dpu2codeprogram4xi.DPU2Kernel4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-DPU2Kernel4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   dpu2codeprogram4xi5test.txt
#   sense-dpu2codeprogram4xi5test.xml
#   reason-dpu2codeprogram4xi5test.xml
#   ace-dpu2codeprogram4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of dpu2kernel4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
